(*
 *   FeedReader
 *   Copyright (C) 2003 The FeedReader Developement Group
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *)
unit AddNewFeedForm_FRM;

interface

uses
  Windows, Messages, httpprot, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls,comctrls;

type
  TAddNewFeedForm = class(TForm)
    Panel1: TPanel;
    Button2: TButton;
    Button1: TButton;
    Panel2: TPanel;
    Button3: TButton;
    Button4: TButton;
    CheckBox1: TCheckBox;
    Label7: TLabel;
    Image1: TImage;
    Image3: TImage;
    un: TLabeledEdit;
    pw: TLabeledEdit;
    edit3: TLabeledEdit;
    panel_usernamehint: TPanel;
    Label6: TLabel;
    Image2: TImage;
    edit1: TLabeledEdit;
    combobox_folder: TListBox;
    panel_errormessage: TPanel;
    errorlabel: TLabel;
    Image4: TImage;
    ProgressBar1: TProgressBar;
    Timer1: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure edit3KeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure edit3Change(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    procedure HttpDocData(Sender: TObject; Buffer: Pointer; Len: Integer);
    procedure ShowPanel1;
    procedure ShowPanel2;
    procedure ShowAuthPanel;
  public
    { Public declarations }
  end;

var
  AddNewFeedForm: TAddNewFeedForm;
  pw: string;
  http_response_string:string;

implementation

uses
  XFunctions, MainForm_FRM,
  Misc, LanguageSupport, FReaderProperties;

{$R *.dfm}

procedure TAddNewFeedForm.Button1Click(Sender: TObject);
var
  http: thttpcli;
  newlocation,httplocation:string;

begin
  panel_usernamehint.Visible:=false;
  pw.visible:=false;
  un.Visible:=false;
  panel_errormessage.visible:=false;
  progressbar1.Position:=0;
  progressbar1.Visible:=true;
  combobox_folder.ItemIndex:=0;
  http := nil;
  AddNewFeedForm.tag := 0;
  http_response_string:='';
  edit3.text:=trim(edit3.text);
  if (trim(edit3.text) = '') and not checkbox1.checked then
    exit;
  checkbox1.Visible := false;

  //form1.Caption:=inttostr(pos('nntp://',edit3.text));
  if (not checkbox1.checked) and (pos('ext:', edit3.text) = 0) and (pos('news:', edit3.text) = 0) then
  begin
    try
//      label5.caption := TranslateString('Connecting...');
      button1.Enabled := false;
      http := thttpcli.Create(nil);
      InitHttpClientProxySettings( http );
      if un.text <> '' then
        http.username := un.text;
      if pw.text <> '' then
        http.password := pw.text;
      AddNewFeedForm.edit1.text := '';
      http.OnDocData := HttpDocData;
      http.url := edit3.text;

      http.Get;

    except
    end;
    progressbar1.Visible:=false;
    if (edit1.text = '') and (AddNewFeedForm.tag = 1) and (http.StatusCode = 200) then
    begin
      edit1.Text := 'No name';
      //AddNewFeedForm.Panel2.BringToFront;
      ShowPanel2;
    end;
//    if http.statuscode <> 200 then
//      begin
//      panel_errormessage.visible:=true;
//      errorlabel.Caption:=translatestring(inttostr(http.statuscode));
//      end;

    //redirect to new location
    if http.statuscode = 302 then
    begin
      http_response_string:='';
      newlocation := http.location;
      http.Abort;
      http.OnDocData := HttpDocData;
      http.url:=newlocation;
      http.Get;
      ShowPanel2;
      button1.Enabled := true;
      exit;
    end;

    if http.statuscode = 401 then
    begin
       un.visible:=true;
       pw.Visible:=true;
       panel_usernamehint.visible:=true;
       button1.Enabled := true;
       exit;
    end;
    if http.statuscode = 403 then
    begin
      panel_errormessage.visible:=true;
      errorlabel.Caption:=translatestring('You are not allowed to connect to this internet address.')+' '+translatestring('Please check if you have entered right address.');
    end;
    if http.statuscode = 404 then
    begin
      if http.lastresponse <> '' then
      begin
      panel_errormessage.visible:=true;
      errorlabel.Caption:=translatestring('Server was found but document You requested is not available.')+' '+translatestring('Please check if you have entered right address.');
      end
      else
      begin
      panel_errormessage.visible:=true;
      errorlabel.Caption:=TranslateString('We could not find a server by this server name.')+' '+translatestring('Please check if you have entered right address.');

      end;
    end;
    if (AddNewFeedForm.tag = 0) and (http.StatusCode = 200) then
    begin
      panel_errormessage.visible:=true;
      errorlabel.Caption:=translatestring('Server was found but internet address You submitted does not contain feed subscription information.')+' '+translatestring('Please check if you have entered right address.');
    end;
    button1.Enabled := true;
  end
  else
  begin
//    panel2.bringtofront;
    ShowPanel2;
  end;
end;

procedure TAddNewFeedForm.Button2Click(Sender: TObject);
begin
  close;
end;

procedure TAddNewFeedForm.Button3Click(Sender: TObject);
begin
//  panel1.BringToFront;
  ShowPanel1;
  edit1.text := '';
end;

procedure TAddNewFeedForm.Button4Click(Sender: TObject);
var targetnode,n:ttreenode;
    parenttype:string;
begin
  targetnode := nil;
  parenttype:='';
  if combobox_folder.itemindex<1 then targetnode:=MainForm_FRM.gMyFeedsTreeNode
  else begin
  n := gMyFeedsTreeNode.getFirstChild;
    while (n <> nil) and (n.data <> nil) and (n.Level > 0) do
    begin
      if Tfeedinfo(n.Data).tiitel = combobox_folder.items[combobox_folder.itemindex] then
      begin
      targetnode:=n;
      parenttype:='folder';
      break;
      end;
      n := n.GetNext;
    end;
  end;
  if targetnode=nil then targetnode:=MainForm_FRM.gMyFeedsTreeNode;
  with mainwindow.treeview1.Items.addchild(targetnode, edit1.text) do
  begin
    data := Tfeedinfo.create;
    Tfeedinfo(data).feedid := strtofloat(floattostr(TimeStampToMSecs(DateTimeToTimeStamp(now))));
    Tfeedinfo(data).id := gMyFeedsTreeNode.Count + 10 + 1;
    Tfeedinfo(data).link := AddNewFeedForm.edit3.text;
    if un.text <> '' then
      Tfeedinfo(data).un := un.text;
    if pw.text <> '' then
      Tfeedinfo(data).pw := pw.text;
    Tfeedinfo(data).htmlurl := '';
    if (pos('news://', edit3.text) > 0) or (pos('ext://', edit3.text) > 0) then
      Tfeedinfo(data).feedtype := 'ext'
    else if checkbox1.checked then
    begin
      imageindex := 28;
      selectedindex := 28;
      Tfeedinfo(data).feedtype := 'localfeed';
    end
    else
      Tfeedinfo(data).feedtype := 'http';
    Tfeedinfo(data).tiitel := edit1.text;
    Tfeedinfo(data).updateperiod := DefaultFeedRefreshIdValue;
    Tfeedinfo(data).ArchiveSize := DefaultArchiveSizeIdValue;

    SetLength( gSubscribedFeeds, Length(gSubscribedFeeds) + 1 );
    gSubscribedFeeds[ Length(gSubscribedFeeds)-1 ].unreadcount := '0';
    gSubscribedFeeds[ Length(gSubscribedFeeds)-1 ].feedtype := Tfeedinfo(data).feedtype;
    gSubscribedFeeds[ Length(gSubscribedFeeds)-1 ].username := un.text;
    gSubscribedFeeds[ Length(gSubscribedFeeds)-1 ].password := pw.text;
    gSubscribedFeeds[ Length(gSubscribedFeeds)-1 ].parent := parenttype;
    gSubscribedFeeds[ Length(gSubscribedFeeds)-1 ].link := edit3.Text;
    gSubscribedFeeds[ Length(gSubscribedFeeds)-1 ].title := edit1.text;
    gSubscribedFeeds[ Length(gSubscribedFeeds)-1 ].htmlurl := '';
    gSubscribedFeeds[ Length(gSubscribedFeeds)-1 ].updateperiod := DefaultFeedRefreshIdValue;
    gSubscribedFeeds[ Length(gSubscribedFeeds)-1 ].unread := '0';
    gSubscribedFeeds[ Length(gSubscribedFeeds)-1 ].feedid := Tfeedinfo(data).feedid;
    gSubscribedFeeds[ Length(gSubscribedFeeds)-1 ].ArchiveSize := DefaultArchiveSizeIdValue;
    get_fav_icon(edit3.Text);
    imageindex:=insertfavicon(Tfeedinfo(data).link);
    selectedindex:=imageindex;
    //selected:=true;
  end;
  AddNewFeedForm.Close;
  AddNewFeedForm.edit3.text := 'http://';
//  AddNewFeedForm.Panel1.BringToFront;
//  ShowPanel1;
  if gMyFeedsTreeNode.count = 1 then
    gMyFeedsTreeNode.expand(true);
    misc.SaveSubscribedFeeds(mainwindow,gMyFeedsTreeNode);
end;

procedure TAddNewFeedForm.edit3KeyPress(Sender: TObject; var Key: Char);
begin
  if key = #13 then
  begin
    Button1Click(sender);
    key := #0;
  end;
end;

procedure TAddNewFeedForm.FormShow(Sender: TObject);
begin
  ShowPanel1;
  edit3.SetFocus;
  un.visible:=false;
  pw.Visible:=false;
  panel_usernamehint.visible:=false;
  button1.Enabled:=false;
  panel_errormessage.Visible:=false;
  un.clear;
  pw.clear;
  edit3.Clear;
end;

procedure TAddNewFeedForm.CheckBox1Click(Sender: TObject);
begin
  if checkbox1.checked then
  begin
    button1.Click;
  end;
end;

procedure TAddNewFeedForm.HttpDocData(Sender: TObject; Buffer: Pointer; Len: Integer);
var
  px: ^string;
begin
  px := @buffer;
  http_response_string := http_response_string + px^;
  //FOR RSS FEED
  if (pos('<title', http_response_string) > 0) and (pos('<channel', http_response_string) > 0) and (edit1.text = '') then
  begin
    http_response_string := copy(http_response_string, pos('<title', http_response_string) + 6, length(http_response_string));
    http_response_string := Copy(http_response_string, Pos('>', http_response_string)+1, Length(http_response_string));
    http_response_string := copy(http_response_string, 1, pos('</title>', http_response_string) - 1);
    Self.tag := 1;
    if (http_response_string <> '') then begin
      edit1.text := trim(html2normal(http_response_string));
      Showpanel2;
    end;
  end;
  //FOR ATOM FEED
  if (pos('<entry', http_response_string) > 0) and (pos('<feed', http_response_string) > 0) and (edit1.text = '') then
  begin
    http_response_string := copy(http_response_string, pos('<title', http_response_string) + 6, length(http_response_string));
    http_response_string := Copy(http_response_string, Pos('>', http_response_string)+1, Length(http_response_string));
    http_response_string := copy(http_response_string, 1, pos('</title>', http_response_string) - 1);
    Self.tag := 1;
    if (http_response_string <> '') then begin
      edit1.text := trim(html2normal(http_response_string));
      Showpanel2;
    end;
  end;
end;

procedure TAddNewFeedForm.ShowPanel1;
begin
  Panel1.Visible := true;
  edit3.SetFocus;
  Panel2.Visible := false;
end;

procedure TAddNewFeedForm.ShowPanel2;
begin
  Panel1.Visible := false;
  Panel2.Visible := true;
  Edit1.SetFocus;
end;

procedure TAddNewFeedForm.ShowAuthPanel;
begin
  Panel1.Visible := false;
  Panel2.Visible := false;
  un.SetFocus;
end;

(*
procedure TAddNewFeedForm.FormKeyPress(Sender: TObject; var Key: Char);
var
  AltDown: boolean;
begin
  {
    Multiple Buttons share the same caption and shortcut.
    To make this shortcuts working, interpret the pressed keys and call the
    appropiated buttons.
  }
  {
    Distinguish if one Alt-Key is pressed;
  }
  AltDown := GetKeyState(VK_LMENU) < 0;
  if (not AltDown) then AltDown := GetKeyState(VK_RMENU) < 0;

  if AltDown then
  begin
    {
      Make shortcuts.
    }
    SearchForShortcuts(Key);
  end;
end;
*)


procedure TAddNewFeedForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
mainwindow.Enabled := true;
end;

procedure TAddNewFeedForm.edit3Change(Sender: TObject);
begin
button1.enabled:=(length(edit3.Text)>0);
end;

procedure TAddNewFeedForm.Timer1Timer(Sender: TObject);
begin
if progressbar1.position=progressbar1.Max then progressbar1.position:=0;
progressbar1.position:=progressbar1.position+1;
application.ProcessMessages;
end;

procedure TAddNewFeedForm.FormCreate(Sender: TObject);
begin
translateform(self);
end;

end.
