(*
 *   FeedReader
 *   Copyright (C) 2003 The FeedReader Developement Group
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *)
unit AppClosingForm_FRM;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, FReaderProperties;

type
  TAppClosingForm = class(TForm)
    Image1: TImage;
    Label1: TLabel;
    statusprogress: TProgressBar;
    procedure FormCreate(Sender: TObject);
  private
    FProperties: TFeedreaderProperties;
    procedure SetProperties(const Value: TFeedreaderProperties);
    { Private declarations }
  public
    { Public declarations }
    property Properties: TFeedreaderProperties read FProperties write SetProperties;
  end;

var
  AppClosingForm: TAppClosingForm;

implementation
uses
  LanguageSupport;

{$R *.dfm}

{ TAppClosingForm }

procedure TAppClosingForm.FormCreate(Sender: TObject);
begin
  TranslateForm(self);
end;

procedure TAppClosingForm.SetProperties(
  const Value: TFeedreaderProperties);
begin
  FProperties := Value;
  {
    Adjust Label position so that it fits on the form, no matter which language
    is used.
  }
  Label1.Left := self.ClientWidth - Label1.Width;
end;

end.
