(*
 *   FeedReader
 *   Copyright (C) 2003 The FeedReader Developement Group
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *)
unit AppOptionsDialog_FRM;

interface

uses
  XFunctions, Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls,
  Forms, CommCtrl,
  Dialogs, ComCtrls, StdCtrls, ImgList, ExtCtrls;

type
  TAppOptionsDialog = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    btnOK: TButton;
    TabSheet3: TTabSheet;
    Button6: TButton;
    lblFontName: TLabel;
    Label5: TLabel;
    GroupBox1: TGroupBox;
    Label6: TLabel;
    vd: TComboBox;
    fade: TCheckBox;
    FontDialog1: TFontDialog;
    Label7: TLabel;
    ImageList1: TImageList;
    OptionTree: TTreeView;
    TabSheet4: TTabSheet;
    GroupBox2: TGroupBox;
    chkEnableWebView: TCheckBox;
    Label8: TLabel;
    edtPort: TEdit;
    GroupBox3: TGroupBox;
    Label9: TLabel;
    cboDefaultFeedRefresh: TComboBox;
    btnCancel: TButton;
    Label10: TLabel;
    cboDefaultArchiveSize: TComboBox;
    GroupBox4: TGroupBox;
    Label11: TLabel;
    cboUserAgent: TComboBox;
    cbUseDefaultUserAgent: TCheckBox;
    Proxy: TGroupBox;
    enableproxy: TCheckBox;
    checkbox3010: TCheckBox;
    proxyhost: TEdit;
    Label3: TLabel;
    Label2: TLabel;
    proxyusername: TEdit;
    proxyport: TEdit;
    Label4: TLabel;
    btnGetExplorerProxySettings: TButton;
    rgPopupsMode: TRadioGroup;
    GroupBox5: TGroupBox;
    chk_customsounds: TCheckBox;
    edt_soundfile: TEdit;
    btn_browse: TButton;
    OpenDialog1: TOpenDialog;
    TabSheet5: TTabSheet;
    template_page: TMemo;
    template_menu_row: TMemo;
    template_article_row: TMemo;
    Label1: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    btn_changeproxypass: TButton;
    procedure btnOKClick(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure btnGetExplorerProxySettingsClick(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure OptionTreeCollapsing(Sender: TObject; Node: TTreeNode;
      var AllowCollapse: Boolean);
    procedure OptionTreeEditing(Sender: TObject; Node: TTreeNode;
      var AllowEdit: Boolean);
    procedure edtPortExit(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure cbUseDefaultUserAgentClick(Sender: TObject);
    procedure chk_customsoundsClick(Sender: TObject);
    procedure btn_browseClick(Sender: TObject);
    procedure btn_changeproxypassClick(Sender: TObject);
    procedure memo_keydown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
    Function IsPropertyEnabled( ID: Integer ): Boolean;
    Procedure UpdateProperty( ID: Integer; Enabled: Boolean );

    Procedure CheckTreeOption( Node: TTreeNode; Checked: Boolean);
    Function IsTreeOptionChecked( Node: TTreeNode): Boolean;
  public
    { Public declarations }
    Function GetDefaultFeedRefreshID: Integer;
    Procedure SetDefaultFeedRefreshID( ID: Integer );
  end;

implementation

uses
  LanguageSupport,
  FReaderProperties, misc,MainForm_FRM;

{$R *.dfm}

Type
  TAppOption = Record
    ID: Integer;
    Name: String;
  End;

Const
  gAppOptions: Array[0..24] Of TAppOption
    = (
        (ID: -1;   Name: 'Appearance'),
//          (ID: 1000; Name: 'Show time'),
//          (ID: 1010; Name: 'Show date'),
          (ID: 1020; Name: 'Show tree lines'),
          (ID: 1030; Name: 'Show newsfeed images if available'),
          (ID: 1040; Name: 'Show pop-up window on taskbar'),
          (ID: 1050; Name: 'Enable taskbar animation'),
//          (ID: 1060; Name: 'Show all article tags'),
          (ID: 1070; Name: 'Show headlines with topics'),
          (ID: 1080; Name: 'Open links in new browser window'),
          (ID: 1090; Name: 'Show XML errors'),
//          (ID: 1100; Name: 'Show Feed-Hints'),
          (ID: 1110; Name: 'Minimize on close-button click'),
          (ID: 1120; Name: 'Automatic jump to next unread headline in next feed'),
          (ID: 1130; Name: 'Show small icons in toolbar'),
          (ID: 1140; Name: 'Open only one folder at a time'),
          (ID: 1150; Name: 'Show all headlines if selecting folder'),
          (ID: 1160; Name: 'Show only new headlines if selecting folder'),


        (ID: -1;   Name: 'Startup'),
          (ID: 2000; Name: 'Run program on startup'),
          (ID: 2010; Name: 'Start minimized to tray'),
          (ID: 2020; Name: 'Update all feeds on program startup'),

        (ID: -1;   Name: 'Misc'),
          (ID: 3000; Name: 'Play sounds'),
//          (ID: 3010; Name: 'Get proxy settings from IE on startup'),
//          (ID: 3020; Name: 'Enable local Userland-Server'),
//          (ID: 3030; Name: 'Enable local AmphetaDesk-Webserver'),
          (ID: 3040; Name: 'Enable JavaScript'),
          (ID: 3050; Name: 'Force new browser windows'),
          (ID: 3060; Name: 'Keep '+ProgramName+' in foreground if new browser is opened'),
          (ID: 3070; Name: 'Autosave subscriptions and headlines'),
          (ID: 3080; Name: 'Advanced configuration options (requires restart)')
      );

procedure TAppOptionsDialog.FormCreate(Sender: TObject);
Var
  i: Integer;
  Idx: Integer;
  ParentNode: TTreeNode;
  Node: TTreeNode;
begin
  PageControl1.ActivePageIndex := 0;
  checkbox3010.Checked:= gProperties.UseIEProxySettings;

  //if advanced options is enabled, then show following extra configuration options
  tabsheet5.tabVisible:=gproperties.AdvancedOptions;
  //end

  chk_customsounds.Checked:=gProperties.EnableCustomsounds;
  edt_soundfile.Text:=gProperties.SoundFile;

  enableproxy.checked := gProperties.ProxyEnabled;
  proxyhost.text := gProperties.ProxyHost;
  proxyport.text := gProperties.ProxyPort;
  proxyusername.text := gProperties.ProxyUsername;

  vd.Items.Add(TranslateString('5 seconds'));
  vd.Items.Add(TranslateString('10 seconds'));
  vd.Items.Add(TranslateString('20 seconds'));
  vd.Items.Add(TranslateString('30 seconds'));
  vd.Items.Add(TranslateString('40 seconds'));
  vd.Items.Add(TranslateString('50 seconds'));
  vd.Items.Add(TranslateString('1 minute'));
  vd.Items.Add(TranslateString('2 minutes'));

  vd.itemindex := gProperties.VD_ItemIndex;
  fade.checked := gProperties.Fade;

  FontDialog1.Font.Name := gProperties.FontName;
  FontDialog1.Font.Size := gProperties.FontSize;

  chkEnableWebView.Checked := gProperties.EnableWebView;
  edtPort.Text := gProperties.WebViewPort;

  template_page.Text:=gproperties.template_page;
  template_menu_row.Text:=gproperties.template_menu_row;
  template_article_row.Text:=gproperties.template_article_row;

  // Note: Keep the numbers (=ID) added as objects as tey are, because they
  //       are used for backward compatibility
  cboDefaultFeedRefresh.Items.Clear;
  With cboDefaultFeedRefresh.Items Do Begin
    AddObject( TranslateString('Never'), Pointer(13) );

    AddObject( StringReplace(TranslateString('Every %n minutes'), '%n',  '5', [rfreplaceall]), Pointer(1) );
    AddObject( StringReplace(TranslateString('Every %n minutes'), '%n', '10', [rfreplaceall]), Pointer(2) );
    AddObject( StringReplace(TranslateString('Every %n minutes'), '%n', '15', [rfreplaceall]), Pointer(3) );
    AddObject( StringReplace(TranslateString('Every %n minutes'), '%n', '20', [rfreplaceall]), Pointer(4) );
    AddObject( StringReplace(TranslateString('Every %n minutes'), '%n', '25', [rfreplaceall]), Pointer(5) );
    AddObject( StringReplace(TranslateString('Every %n minutes'), '%n', '30', [rfreplaceall]), Pointer(6) );
    AddObject( StringReplace(TranslateString('Every %n minutes'), '%n', '35', [rfreplaceall]), Pointer(7) );
    AddObject( StringReplace(TranslateString('Every %n minutes'), '%n', '40', [rfreplaceall]), Pointer(8) );
    AddObject( StringReplace(TranslateString('Every %n minutes'), '%n', '45', [rfreplaceall]), Pointer(9) );
    AddObject( StringReplace(TranslateString('Every %n minutes'), '%n', '50', [rfreplaceall]), Pointer(10) );
    AddObject( StringReplace(TranslateString('Every %n minutes'), '%n', '55', [rfreplaceall]), Pointer(11) );
    AddObject( StringReplace(TranslateString('Every hour'), '%n', '1', [rfreplaceall]), Pointer(12) );

    AddObject( StringReplace(TranslateString('Every %n hours'), '%n', '2', [rfreplaceall]), Pointer(15) );
    AddObject( StringReplace(TranslateString('Every %n hours'), '%n', '3', [rfreplaceall]), Pointer(16) );
    AddObject( StringReplace(TranslateString('Every %n hours'), '%n', '4', [rfreplaceall]), Pointer(17) );
    AddObject( StringReplace(TranslateString('Every %n hours'), '%n', '5', [rfreplaceall]), Pointer(18) );
    AddObject( StringReplace(TranslateString('Every %n hours'), '%n', '6', [rfreplaceall]), Pointer(19) );
    AddObject( StringReplace(TranslateString('Every %n hours'), '%n', '8', [rfreplaceall]), Pointer(20) );
    AddObject( StringReplace(TranslateString('Every %n hours'), '%n', '12',[rfreplaceall]), Pointer(21) );
    AddObject( StringReplace(TranslateString('Every %n hours'), '%n', '16',[rfreplaceall]), Pointer(22) );
    AddObject( StringReplace(TranslateString('Every %n hours'), '%n', '24', [rfreplaceall]),Pointer(23) );
  End;
  SetDefaultFeedRefreshID( gProperties.DefaultFeedRefresh );


  cboDefaultArchiveSize.Items.Clear;
  For i := 0 To 9 Do
    cboDefaultArchiveSize.AddItem( stringreplace(TranslateString('%n headlines'), '%n', inttostr( Succ(i) * 50), [rfreplaceall]), Pointer( i ) );
  cboDefaultArchiveSize.AddItem( TranslateString('All headlines'), Pointer(UnlimitedArchiveSizeIdValue) );
  if gProperties.DefaultArchiveSize=9999 then
    cboDefaultArchiveSize.ItemIndex:=cboDefaultArchiveSize.Items.Count-1
    else cboDefaultArchiveSize.ItemIndex := gProperties.DefaultArchiveSize;


  SetWindowLong( OptionTree.Handle, GWL_STYLE, GetWindowLong(OptionTree.Handle, GWL_STYLE) Or TVS_CHECKBOXES );

  ParentNode := Nil;
  For i:= Low(gAppOptions) To High(gAppOptions) Do Begin
    If gAppOptions[i].ID < 0 Then Begin
      ParentNode := OptionTree.Items.Add( Nil, TranslateString( gAppOptions[i].Name ) );
      ParentNode.ImageIndex := 0;
      ParentNode.SelectedIndex := 0;
      ParentNode.StateIndex := 0;
      Continue;
    End;

    If ParentNode = Nil Then
      Continue;
    ParentNode.Expand( True );


    Node := OptionTree.Items.AddChild( ParentNode, TranslateString( gAppOptions[i].Name ) );
    Node.Data := Pointer( gAppOptions[i].ID );
    Node.ImageIndex := -1;
    Node.SelectedIndex := -1;
    CheckTreeOption( Node, IsPropertyEnabled( gAppOptions[i].ID ) );
  End;
  If ParentNode <> Nil Then
    ParentNode.Expand( True );

  If OptionTree.Items.GetFirstNode <> Nil Then
    OptionTree.Items.GetFirstNode.MakeVisible;

  Idx := 0;
  cboUserAgent.Items.Clear;
  For i := Low(gUserAgents) To High(gUserAgents) Do Begin
    cboUserAgent.Items.Add( gUserAgents[i] );
    If 0 = CompareText( gUserAgents[i], gProperties.UserAgent ) Then
      Idx := i;
  End;
  cboUserAgent.ItemIndex := Idx;

  cbUseDefaultUserAgent.Checked := gProperties.ChangeUserAgent;
  cboUserAgent.Enabled := cbUseDefaultUserAgent.Checked;

  rgPopupsMode.Items.Clear;
  rgPopupsMode.Items.Add(TranslateString('Show all Popups'));
  rgPopupsMode.Items.Add(TranslateString('Never show Popups'));
  rgPopupsMode.Items.Add(TranslateString('Ask before opening Popups'));


  Case gProperties.ShowPopupsMode Of
    POP_Always: rgPopupsMode.ItemIndex := 0;
    POP_Never:  rgPopupsMode.ItemIndex := 1;
    POP_Ask:    rgPopupsMode.ItemIndex := 2;
   Else
    rgPopupsMode.ItemIndex := 2;
  End;
  btn_changeproxypass.Enabled:=(trim(gproperties.ProxyPassword)<>'');
  TranslateForm(self);
  chk_customsoundsClick(sender);
end;


Function TAppOptionsDialog.GetDefaultFeedRefreshID: Integer;
Var
  i: Integer;
Begin
  i := cboDefaultFeedRefresh.ItemIndex;
  If i < 0 Then
    Result := DefaultFeedRefreshIdValue
   Else
    Result := Integer( cboDefaultFeedRefresh.Items.Objects[i] );
End;


Procedure TAppOptionsDialog.SetDefaultFeedRefreshID( ID: Integer );
Var
  i: Integer;
Begin
  For i := 0 To cboDefaultFeedRefresh.Items.Count-1 Do
    If ID = Integer(cboDefaultFeedRefresh.Items.Objects[i]) Then Begin
      cboDefaultFeedRefresh.ItemIndex := i;
      Break;
    End;
End;


Function TAppOptionsDialog.IsPropertyEnabled( ID: Integer ): Boolean;
Begin
  Case ID Of

    1000: Result := gProperties.ShowTime;
    1010: Result := gProperties.ShowDate;
    1020: Result := gProperties.ShowTreeLines;
    1030: Result := gProperties.ShowNewsFeedImages;
    1040: Result := gProperties.ShowBaloons;
    1050: Result := gProperties.EnableTaskbarAnimations;
    1060: Result := gProperties.ShowAllTags;
    1070: Result := gProperties.ShowTopics;
    1080: Result := gProperties.OpenLinksInNewBrowser;
    1090: Result := gProperties.ShowXmlErrors;
    1100: Result := gProperties.ShowFeedHints;
    1110: Result := gProperties.MinimizeOnCloseButton;
    1120: Result := gProperties.AutoJumpToNextUnreadNextFeed;
    1130: Result := gProperties.ToolbarShowSmallIcons;
    1140: Result := gProperties.OpenOneFolder;
    1150: Result := gProperties.ShowHeadlinesinFolder;
    1160: Result := gProperties.ShowNewHeadlinesinFolder;

    2000: Result := gProperties.RunAtStartup;
    2010: Result := gProperties.StartHidden;
    2020: Result := gProperties.CheckMsgsOnStartup;

    3000: Result := gProperties.PlaySounds;
    3010: Result := gProperties.UseIEProxySettings;
    3020: Result := gProperties.EnableUserlandHttpServer;
    3030: Result := gProperties.EnableAmphetaDeskHttpServer;
    3040: Result := gProperties.EnableJavaScript;
    3050: Result := gProperties.ForceNewBrowserWindow;
    3060: Result := gProperties.KeepInForeground;
    3070: Result := gProperties.Savefilesperiodically;
    3080: Result := gProperties.AdvancedOptions;

  Else
    Result := False;
  End;
End;


Procedure TAppOptionsDialog.UpdateProperty( ID: Integer; Enabled: Boolean );
Begin
  Case ID Of

    1000: gProperties.ShowTime := Enabled;
    1010: gProperties.ShowDate := Enabled;
    1020: gProperties.ShowTreeLines := Enabled;
    1030: gProperties.ShowNewsFeedImages := Enabled;
    1040: gProperties.ShowBaloons := Enabled;
    1050: gProperties.EnableTaskbarAnimations := Enabled;
    1060: gProperties.ShowAllTags := Enabled;
    1070: gProperties.ShowTopics := Enabled;
    1080: gProperties.OpenLinksInNewBrowser := Enabled;
    1090: gProperties.ShowXmlErrors := Enabled;
    1100: gProperties.ShowFeedHints := Enabled;
    1110: gProperties.MinimizeOnCloseButton := Enabled;
    1120: gProperties.AutoJumpToNextUnreadNextFeed := Enabled;
    1130: gProperties.ToolbarShowSmallIcons := Enabled;
    1140: gProperties.OpenOneFolder := Enabled;
    1150: gProperties.ShowHeadlinesinFolder := Enabled;
    1160: gProperties.ShowNewHeadlinesinFolder := Enabled;
          

    2000: gProperties.RunAtStartup := Enabled;
    2010: gProperties.StartHidden := Enabled;
    2020: gProperties.CheckMsgsOnStartup := Enabled;

    3000: gProperties.PlaySounds := Enabled;
    3010: gProperties.UseIEProxySettings := Enabled;
    3020: gProperties.EnableUserlandHttpServer := Enabled;
    3030: gProperties.EnableAmphetaDeskHttpServer := Enabled;
    3040: gProperties.EnableJavaScript := Enabled;
    3050: gProperties.ForceNewBrowserWindow := Enabled;
    3060: gProperties.KeepInForeground := Enabled;
    3070: gProperties.Savefilesperiodically := Enabled;
    3080: gProperties.Advancedoptions := Enabled;

  End;
End;


Procedure TAppOptionsDialog.CheckTreeOption( Node: TTreeNode; Checked: Boolean);
Var
  tvItem: TTVItem;
Begin

    tvItem.mask := TVIF_HANDLE Or TVIF_STATE;
    tvItem.hItem := Node.ItemId;
    tvItem.stateMask := TVIS_STATEIMAGEMASK;

    If Checked Then
      tvItem.state := INDEXTOSTATEIMAGEMASK( 2 )
    Else
      tvItem.state := INDEXTOSTATEIMAGEMASK( 1 );

    TreeView_SetItem( OptionTree.Handle, tvItem );
End;


Function TAppOptionsDialog.IsTreeOptionChecked( Node: TTreeNode): Boolean;
Var
  tvItem: TTVItem;
Begin

    tvItem.mask := TVIF_HANDLE Or TVIF_STATE;
    tvItem.hItem := Node.ItemId;
    tvItem.stateMask := TVIS_STATEIMAGEMASK;

    TreeView_GetItem( OptionTree.Handle, tvItem );

    Result := (tvItem.state SHR 12) = 2;
End;


procedure TAppOptionsDialog.btnOKClick(Sender: TObject);
Var
  ID: Integer;
  i: Integer;
begin
  gProperties.Language := GetUsedLanguage;

  gProperties.template_page:=template_page.Text;
  gProperties.template_menu_row:=template_menu_row.Text;
  gProperties.template_article_row:=template_article_row.Text;

  gProperties.VD_ItemIndex := vd.itemindex;
  gProperties.Fade := fade.checked;

  gProperties.FontName:= fontdialog1.Font.Name;
  gProperties.FontSize := fontdialog1.Font.size;

  gProperties.EnableCustomsounds := chk_customsounds.Enabled;
  gProperties.SoundFile := edt_soundfile.Text;

  gProperties.EnableWebView := chkEnableWebView.Checked;
  gProperties.WebViewPort := edtPort.Text;

  gProperties.DefaultFeedRefresh := GetDefaultFeedRefreshID;

  For i := 0 To OptionTree.Items.Count-1 Do Begin
    ID := Integer( OptionTree.Items[i].Data );
    UpdateProperty( ID, IsTreeOptionChecked( OptionTree.Items[i] ) );
  End;

  gProperties.DefaultArchiveSize := Integer( Pointer(cboDefaultArchiveSize.Items.Objects[ cboDefaultArchiveSize.ItemIndex ]) );

  gProperties.ProxyEnabled := enableproxy.checked;
  gProperties.UseIEProxySettings:=checkbox3010.Checked;
  gProperties.ProxyHost := proxyhost.text;
  gProperties.ProxyPort := proxyport.text;
  gProperties.ProxyUsername := proxyusername.text;

  If gProperties.ProxyEnabled Then
    if gProperties.ProxyPassword = '' then
      if gProperties.ProxyUsername <> '' Then
        gProperties.ProxyPassword := InputBox( TranslateString('Enter proxy server password'), TranslateString('for user') + ' ' + gProperties.ProxyUsername, '');

  gProperties.ChangeUserAgent := cbUseDefaultUserAgent.Checked;
  if gProperties.ChangeUserAgent then
    gProperties.UserAgent := cboUserAgent.Items[ cboUserAgent.ItemIndex ]
  else
    gProperties.UserAgent := ReadIEUserAgent;


  Case rgPopupsMode.ItemIndex Of
    0: gProperties.ShowPopupsMode := POP_Always;
    1: gProperties.ShowPopupsMode := POP_Never;
    2: gProperties.ShowPopupsMode := POP_Ask;
   Else
    gProperties.ShowPopupsMode := POP_Ask;
  End;
    if (gProperties.ToolbarShowSmallIcons) then mainwindow.ActionManager1.Images:=mainwindow.imagelist2 else mainwindow.ActionManager1.Images:=mainwindow.imagelist_bigimages;
    mainwindow.Actiontoolbar1.RecreateControls;
    misc.place_searchbox;
end;

procedure TAppOptionsDialog.Button6Click(Sender: TObject);
begin
fontdialog1.Execute;
    lblFontName.caption := fontdialog1.Font.Name + ' ' +
                           inttostr(fontdialog1.Font.Size) + ' pts';

end;

procedure TAppOptionsDialog.btnGetExplorerProxySettingsClick(Sender: TObject);
begin
  enableproxy.checked := gProperties.ProxyEnabled;
  proxyhost.text := gProperties.ProxyHost;
  proxyport.Text := gProperties.ProxyPort;
end;

procedure TAppOptionsDialog.PageControl1Change(Sender: TObject);
begin
  if pagecontrol1.ActivePageIndex = 2 then
    lblFontName.caption := gProperties.FontName + ' ' +
                           inttostr(gProperties.FontSize) + ' pts';
end;

procedure TAppOptionsDialog.OptionTreeCollapsing(Sender: TObject; Node: TTreeNode;
  var AllowCollapse: Boolean);
begin
  AllowCollapse := False;
end;

procedure TAppOptionsDialog.OptionTreeEditing(Sender: TObject; Node: TTreeNode;
  var AllowEdit: Boolean);
begin
  AllowEdit := False;
end;

procedure TAppOptionsDialog.edtPortExit(Sender: TObject);
Var
  i: Integer;
begin
  i := StrToIntDef( edtPort.Text, -1 );
  If (i < 0) Or (i > 65535) Then i := StrToIntDef(gProperties.WebViewPort, 80);
  edtPort.Text := IntToStr( i );
end;

procedure TAppOptionsDialog.btnCancelClick(Sender: TObject);
begin
  Self.Close;
end;

procedure TAppOptionsDialog.cbUseDefaultUserAgentClick(Sender: TObject);
begin
  cboUserAgent.Enabled := cbUseDefaultUserAgent.Checked;
end;

procedure TAppOptionsDialog.chk_customsoundsClick(Sender: TObject);
begin
edt_soundfile.Enabled:=chk_customsounds.Checked;
btn_browse.Enabled:=chk_customsounds.Checked;
end;

procedure TAppOptionsDialog.btn_browseClick(Sender: TObject);
begin
opendialog1.InitialDir:=gproperties.ApplicationDirectory;
if opendialog1.Execute then edt_soundfile.Text:=opendialog1.FileName;
end;

procedure TAppOptionsDialog.btn_changeproxypassClick(Sender: TObject);
begin
gProperties.ProxyPassword := InputBox( TranslateString('Enter proxy server password'), TranslateString('for user') + ' ' + gProperties.ProxyUsername, '');

end;

procedure TAppOptionsDialog.memo_keydown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
    if (Key = Ord('A')) and (ssCtrl in Shift) then
   begin
     TMemo(Sender).SelectAll;
     Key := 0;
   end;
   end;

end.
