library pop3client;

{ Important note about DLL memory management: ShareMem must be the
  first unit in your library's USES clause AND your project's (select
  Project-View Source) USES clause if your DLL exports any procedures or
  functions that pass strings as parameters or function results. This
  applies to all strings passed to and from your DLL--even those that
  are nested in records and classes. ShareMem is the interface unit to
  the BORLNDMM.DLL shared memory manager, which must be deployed along
  with your DLL. To avoid using BORLNDMM.DLL, pass string information
  using PChar or ShortString parameters. }

uses
  SysUtils,
  shellapi,
  Classes,
  Dialogs,
  Contnrs,
  Windows,
  Messages,
  Variants,
  Graphics,
  Controls,
  Forms,
  ExtCtrls,
  StdCtrls,
  IdPOP3,IdMessage,
  ComCtrls;

type
  THeadline = class
    tiitel, link, linkdoc, sisu, image, topic, creator: string;
    date, comments, section, other,modified: string;
    SourceDescription, SourceURL: String;
    deleted: boolean;
    read,flag,rating: integer;
    hlid, owner: real;
    enclosure: boolean;
    enc_url, enc_size, enc_type: string;
    guid: String;
    itemtype:string;
  end;
  Tfeedinfo = class
    link, htmlurl, un, pw, feedtype,LastModified, description, image, tiitel, sisu: string;
    updateperiod, id, read, unreadcount: integer;
    feedid: real;
    Hint: String;
    ArchiveSize: Integer;
    AlwaysShowLink: Boolean;

    UpdateThread: TObject;
  end;
type ext_info=class
  name,desc,author,version:string;
  ext_version:integer;
  action_open_item,action_update,action_config:boolean;
  action_open_item_name,action_update_type:string;
end;
{$R *.res}

//return information about dll

function get_ext_info:ext_info;
var tmp_ei:ext_info;
begin
tmp_ei:=ext_info.create;
tmp_ei.name:='Pop3 mail checker';
tmp_ei.desc:='Configure feed as ext://pop3client.dll/www.somehost.com. Also add username and password';
tmp_ei.author:='Toomas Toots';
tmp_ei.version:='1.0';
tmp_ei.ext_version:=1;
tmp_ei.action_open_item:=false;
tmp_ei.action_update:=true;
tmp_ei.action_config:=false;
tmp_ei.action_open_item_name:='Email';
tmp_ei.action_update_type:='pop3';
get_ext_info:=tmp_ei;
end;
function action_update(URL, LastModified, Username, Password:string):tobjectlist;
var ol:tobjectlist;
var myheadline:theadline;
pop:tidpop3;
msg:tidmessage;
i,limit,total:integer;
tmpdatetime:string;
year,month,day,hour,min,sec,msec:word;
begin
limit:=13;
msg:=tidmessage.Create(nil);
ol:=tobjectlist.Create;
url:=copy(url,7,length(url));
url:=trim(copy(url,pos('/',url)+1,length(url)));
pop:=tidpop3.Create(nil);
pop.Username:=username;
pop.Password:=password;
pop.Host:=url;
try
pop.Connect(60000);
total:=pop.CheckMessages;
  for i:=total downto 0 do
    begin
    if i<total-limit then break;
    Msg.Clear;
    POP.RetrieveHeader(i, Msg);
    //format datetime
    DecodeDate(msg.Date, Year, Month, Day);
    DecodeTime(msg.date, Hour, Min, Sec, MSec);
    tmpdatetime := IntToStr(Year) + '-' + Format('%.2d', [Month]) + '-' + Format('%.2d', [Day]) + 'T' + Format('%.2d', [Hour]) + ':' + Format('%.2d', [Min]) + ':' + Format('%.2d', [Sec]);
    tmpdatetime := tmpdatetime + '+00:99';

    //end of formating datetime
    myheadline:=theadline.Create;
    myheadline.date:=tmpdatetime;
    myheadline.sisu:=stringreplace(stringreplace(msg.MsgId,'<','',[rfreplaceall]),'>','',[rfreplaceall]);
    myheadline.guid:=msg.MsgId;
    myheadline.creator:=msg.from.Name+' &lt;'+msg.from.Address+'&gt;';
    myheadline.tiitel:=msg.Subject;
    myheadline.link:=stringreplace(stringreplace(msg.MsgId,'<','',[rfreplaceall]),'>','',[rfreplaceall]);
    ol.add(myheadline);
    end;
except
end;
if pop.Connected then pop.Disconnect;
pop.Free;
action_update:=ol;
end;
function show_action_open_item(headline:theadline):ShortString;
begin
show_action_open_item:='';
end;
procedure action_open_item(headline:theadline);
begin
end;
procedure action_configure;
begin
end;

//------------------------------------------------
exports get_ext_info;
exports action_update;
exports show_action_open_item;
end.
