library sendmail;

{ Important note about DLL memory management: ShareMem must be the
  first unit in your library's USES clause AND your project's (select
  Project-View Source) USES clause if your DLL exports any procedures or
  functions that pass strings as parameters or function results. This
  applies to all strings passed to and from your DLL--even those that
  are nested in records and classes. ShareMem is the interface unit to
  the BORLNDMM.DLL shared memory manager, which must be deployed along
  with your DLL. To avoid using BORLNDMM.DLL, pass string information
  using PChar or ShortString parameters. }

uses
  SysUtils,
  shellapi,
  Classes,
  Dialogs,
  Contnrs,
    Windows, Messages, Variants, Graphics, Controls, Forms, ExtCtrls, StdCtrls, ComCtrls,

  form_configure_unit in 'form_configure_unit.pas' {form_configure};
type
  THeadline = class
    tiitel, link, linkdoc, sisu, image, topic, creator: string;
    date, comments, section, other,modified: string;
    SourceDescription, SourceURL: String;
    deleted: boolean;
    read,flag,rating: integer;
    hlid, owner: real;
    enclosure: boolean;
    enc_url, enc_size, enc_type: string;
    guid: String;
    itemtype:string;
  end;
  Tfeedinfo = class
    link, htmlurl, un, pw, feedtype,LastModified, description, image, tiitel, sisu: string;
    updateperiod, id, read, unreadcount: integer;
    feedid: real;
    Hint: String;
    ArchiveSize: Integer;
    AlwaysShowLink: Boolean;

    UpdateThread: TObject;
  end;
type ext_info=class
  name,desc,author,version:string;
  ext_version:integer;
  action_open_item,action_update,action_config:boolean;
  action_open_item_name,action_update_type:string;
end;
{$R *.res}

//return information about dll

function get_ext_info:ext_info;
var tmp_ei:ext_info;
begin
tmp_ei:=ext_info.create;
tmp_ei.name:='Send article by email';
tmp_ei.desc:='Simple extension that allows to send current article using default email program. Body is limited to 1000 characters.';
tmp_ei.author:='Toomas Toots';
tmp_ei.version:='1.0';
tmp_ei.ext_version:=1;
tmp_ei.action_open_item:=true;
tmp_ei.action_update:=false;
tmp_ei.action_config:=false;
tmp_ei.action_open_item_name:='Email';
tmp_ei.action_update_type:='pop3';
get_ext_info:=tmp_ei;
end;
function action_update(URL, LastModified, Username, Password:string):tobjectlist;
var ol:tobjectlist;
var myheadline:theadline;
begin
ol:=tobjectlist.Create;
myheadline:=theadline.Create;
myheadline.tiitel:='Testoutput';
ol.add(myheadline);
action_update:=ol;
end;
function show_action_open_item(headline:theadline):ShortString;
begin
//control if you want to show action link according to headline attributes
show_action_open_item:='Mail';
end;
procedure action_open_item(headline:theadline);
var handle:thandle;
var part1,part2,part3:string;
begin
part1:='mailto:?subject='+headline.tiitel;
part2:='&body='+headline.link;
part3:=#13#10#13#10+headline.link;
ShellExecute(handle, nil, pchar(part1+part2), Nil, Nil, SW_SHOWNORMAL);
end;
procedure action_configure;
var fc:tform_configure;
begin
fc:=tform_configure.Create(nil);
fc.ShowModal;
//
end;

//------------------------------------------------
exports get_ext_info;
exports action_update;
exports show_action_open_item;
exports action_open_item;
exports action_configure;
end.
