unit ExtensionsForm_FRM;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, XPMan, StdCtrls, ComCtrls,LanguageSupport;
type ext_info=class
  name,desc,author,version:string;
  ext_version:integer;
  action_open_item,action_update,action_config:boolean;
  action_open_item_name,action_update_type:string;
end;
  type tgetinfo=function:ext_info;
  type taction_configure=procedure;

type
  TExtensionsForm = class(TForm)
    ListView1: TListView;
    Memo1: TMemo;
    Button1: TButton;
    Button2: TButton;
    XPManifest1: TXPManifest;
    procedure Button1Click(Sender: TObject);
    procedure ListView1Change(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ExtensionsForm: TExtensionsForm;
  dllhandle : THandle;
implementation

{$R *.dfm}

procedure TExtensionsForm.Button1Click(Sender: TObject);
var action_configure:taction_configure;
begin
if listview1.Selected=nil then exit;
        DLLHandle := LoadLibrary(pchar(listview1.Selected.Caption));
        if DLLHandle <> 0 then
        begin
          @action_configure := GetProcAddress(DLLHandle, 'action_configure');
          if assigned(action_configure) then action_configure;
        end;

end;

procedure TExtensionsForm.ListView1Change(Sender: TObject; Item: TListItem;
  Change: TItemChange);
begin
if assigned(item.data) then
begin
memo1.Text:=ext_info(item.data).desc;
button1.Enabled:=ext_info(item.data).action_config;
end;
end;

procedure TExtensionsForm.Button2Click(Sender: TObject);
begin
close;
end;

procedure TExtensionsForm.FormCreate(Sender: TObject);
var
sr: TSearchRec;
  FileAttrs: Integer;
minuproc:tgetinfo;
di:ext_info;
begin
TranslateForm(self);
fileattrs:=0;
FileAttrs := FileAttrs + faAnyFile;
if FindFirst('*.dll', FileAttrs, sr) = 0 then

    begin
      repeat
        with listview1.Items.add do
        begin
        caption := sr.Name;


        DLLHandle := LoadLibrary(pchar(sr.name));
        if DLLHandle <> 0 then
        begin
          @minuproc := GetProcAddress(DLLHandle, 'get_ext_info');
          if assigned(minuproc) then
          begin
          di:=minuproc;
          data:=ext_info.Create;
          data:=di;
          subitems.Add(di.name);
          subitems.add(di.version);
          if di.action_open_item then subitems.add('+') else subitems.add('-');
          if di.action_update then subitems.add('+') else subitems.add('-');
        end;
 end;
        end;
      until FindNext(sr) <> 0;
      FindClose(sr);
    end;



end;

procedure TExtensionsForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
release;
end;

end.
