(*
 *   FeedReader
 *   Copyright (C) 2003 The FeedReader Developement Group
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *)
unit FeedPropertiesForm_FRM;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TFeedPropertiesForm = class(TForm)
    edit1: TEdit;
    edit2: TEdit;
    Label4: TLabel;
    cancelbutton: TButton;
    button1: TButton;
    Bevel2: TBevel;
    Label2: TLabel;
    cboUpdatePeriod: TComboBox;
    Label6: TLabel;
    un: TEdit;
    Label7: TLabel;
    pw: TEdit;
    Label1: TLabel;
    cboArchiveSize: TComboBox;
    chkAlwaysShowLink: TCheckBox;
    Image1: TImage;
    Bevel1: TBevel;
    chk_allowaccessfromweb: TCheckBox;
    procedure button1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cancelbuttonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Function GetUpdatePeriodId: Integer;
    Procedure SetUpdatePeriodId( ID: Integer );
    Function GetArchiveSizeID: Integer;
    Procedure SetArchiveSizeID( ID: Integer );
  end;

Var
  FeedPropertiesForm: TFeedPropertiesForm;

implementation

uses
  Misc, LanguageSupport, FReaderProperties, MainForm_FRM;

{$R *.DFM}

Function TFeedPropertiesForm.GetUpdatePeriodId: Integer;
Var
  i: Integer;
Begin
  i := cboUpdatePeriod.ItemIndex;
  If i < 0 Then
    Result := DefaultFeedRefreshIdValue
   Else
    Result := Integer( cboUpdatePeriod.Items.Objects[i] );
End;


Procedure TFeedPropertiesForm.SetUpdatePeriodId( ID: Integer );
Var
  i: Integer;
Begin
  For i := 0 To cboUpdatePeriod.Items.Count-1 Do
    If ID = Integer(cboUpdatePeriod.Items.Objects[i]) Then Begin
      cboUpdatePeriod.ItemIndex := i;
      Break;
    End;
End;

Function TFeedPropertiesForm.GetArchiveSizeID: Integer;
Var
  i: Integer;
Begin
  i := cboArchiveSize.ItemIndex;
  If i < 0 Then
    Result := DefaultArchiveSizeIdValue
   Else
    Result := Integer( cboArchiveSize.Items.Objects[i] );
End;


Procedure TFeedPropertiesForm.SetArchiveSizeID( ID: Integer );
Var
  i: Integer;
Begin
  For i := 0 To cboArchiveSize.Items.Count-1 Do
    If ID = Integer(cboArchiveSize.Items.Objects[i]) Then Begin
      cboArchiveSize.ItemIndex := i;
      Break;
    End;
End;

procedure TFeedPropertiesForm.button1Click(Sender: TObject);
Var
  FeedID: Real;
  i: Integer;
begin
  EnterCriticalSection(gCritSect);
  try
    FeedID := Tfeedinfo(mainwindow.treeview1.Selected.data).feedid;
    For i := Low(gSubscribedFeeds) To High(gSubscribedFeeds) Do
      If gSubscribedFeeds[i].feedid = FeedID Then Begin
        gSubscribedFeeds[i].AlwaysShowLink := chkAlwaysShowLink.Checked;
        gSubscribedFeeds[i].allowfromweb := chk_allowaccessfromweb.Checked;
        gSubscribedFeeds[i].updateperiod := GetUpdatePeriodId;
        gSubscribedFeeds[i].title := edit1.Text;
        gSubscribedFeeds[i].link := edit2.Text;
        gSubscribedFeeds[i].username := un.text;
        gSubscribedFeeds[i].password := pw.Text;
        gSubscribedFeeds[i].ArchiveSize := GetArchiveSizeID;
        Break;
      End;

    Tfeedinfo(mainwindow.treeview1.Selected.data).updateperiod := GetUpdatePeriodId;
    Tfeedinfo(mainwindow.treeview1.Selected.data).tiitel := edit1.text;
    Tfeedinfo(mainwindow.treeview1.Selected.data).link := edit2.text;
    Tfeedinfo(mainwindow.treeview1.Selected.data).un := un.text;
    Tfeedinfo(mainwindow.treeview1.Selected.data).pw := pw.text;
    Tfeedinfo(mainwindow.treeview1.Selected.data).ArchiveSize := GetArchiveSizeID;
    Tfeedinfo(mainwindow.treeview1.Selected.data).allowfromweb := chk_allowaccessfromweb.Checked;
    Tfeedinfo(mainwindow.treeview1.Selected.data).AlwaysShowLink := ChkAlwaysShowLink.Checked;
    mainwindow.TreeView1.selected.Text := edit1.text;
    Tfeedinfo(mainwindow.treeview1.Selected.data).link := edit2.text;
  finally
    LeaveCriticalSection(gCritSect);
  end;

  Self.close;
end;

procedure TFeedPropertiesForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  mainwindow.enabled := TRUE;
end;

procedure TFeedPropertiesForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = 27 then
    close;
end;

procedure TFeedPropertiesForm.Button2Click(Sender: TObject);
begin
  mainwindow.Deleteheadlines1Click(sender);
  Self.Close
end;

procedure TFeedPropertiesForm.FormCreate(Sender: TObject);
var
  i: integer;
begin
  TranslateAllForms;

  // Note: Keep the numbers (=ID) added as objects as tey are, because they
  //       are used for backward compatibility
  cboUpdatePeriod.Items.Clear;
  With cboUpdatePeriod.Items DO Begin
    AddObject( TranslateString('Default period'), Pointer(14) );
    AddObject( TranslateString('Never'), Pointer(13) );

    AddObject( StringReplace(TranslateString('Every %n minutes'), '%n',  '5', [rfreplaceall]), Pointer(1) );
    AddObject( StringReplace(TranslateString('Every %n minutes'), '%n', '10', [rfreplaceall]), Pointer(2) );
    AddObject( StringReplace(TranslateString('Every %n minutes'), '%n', '15', [rfreplaceall]), Pointer(3) );
    AddObject( StringReplace(TranslateString('Every %n minutes'), '%n', '20', [rfreplaceall]), Pointer(4) );
    AddObject( StringReplace(TranslateString('Every %n minutes'), '%n', '25', [rfreplaceall]), Pointer(5) );
    AddObject( StringReplace(TranslateString('Every %n minutes'), '%n', '30', [rfreplaceall]), Pointer(6) );
    AddObject( StringReplace(TranslateString('Every %n minutes'), '%n', '35', [rfreplaceall]), Pointer(7) );
    AddObject( StringReplace(TranslateString('Every %n minutes'), '%n', '40', [rfreplaceall]), Pointer(8) );
    AddObject( StringReplace(TranslateString('Every %n minutes'), '%n', '45', [rfreplaceall]), Pointer(9) );
    AddObject( StringReplace(TranslateString('Every %n minutes'), '%n', '50', [rfreplaceall]), Pointer(10) );
    AddObject( StringReplace(TranslateString('Every %n minutes'), '%n', '55', [rfreplaceall]), Pointer(11) );
    AddObject( StringReplace(TranslateString('Every hour'), '%n', '1', [rfreplaceall]), Pointer(12) );

    AddObject( StringReplace(TranslateString('Every %n hours'), '%n', '2', [rfreplaceall]), Pointer(15) );
    AddObject( StringReplace(TranslateString('Every %n hours'), '%n', '3', [rfreplaceall]), Pointer(16) );
    AddObject( StringReplace(TranslateString('Every %n hours'), '%n', '4', [rfreplaceall]), Pointer(17) );
    AddObject( StringReplace(TranslateString('Every %n hours'), '%n', '5', [rfreplaceall]), Pointer(18) );
    AddObject( StringReplace(TranslateString('Every %n hours'), '%n', '6', [rfreplaceall]), Pointer(19) );
    AddObject( StringReplace(TranslateString('Every %n hours'), '%n', '8', [rfreplaceall]), Pointer(20) );
    AddObject( StringReplace(TranslateString('Every %n hours'), '%n', '12',[rfreplaceall]), Pointer(21) );
    AddObject( StringReplace(TranslateString('Every %n hours'), '%n', '16',[rfreplaceall]), Pointer(22) );
    AddObject( StringReplace(TranslateString('Every %n hours'), '%n', '24', [rfreplaceall]),Pointer(23) );
  End;

  cboArchiveSize.AddItem( TranslateString('Default'), Pointer(DefaultArchiveSizeIdValue) );
  for i := 0 to 9 do
    cboArchiveSize.AddItem( stringreplace(TranslateString('%n headlines'), '%n', inttostr( Succ(i) * 50), [rfreplaceall]), Pointer( i ) );
  cboArchiveSize.AddItem( TranslateString('All headlines'), Pointer(UnlimitedArchiveSizeIdValue) );
end;

procedure TFeedPropertiesForm.cancelbuttonClick(Sender: TObject);
begin
  Self.Close;
end;

end.
