unit FiltersForm_FRM;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ExtCtrls,LanguageSupport;
type
  feednumber = class
    id:real;
    action:integer;
    keyword:string;
    option:integer;
  end;
type
  TFiltersForm = class(TForm)
    ListView1: TListView;
    GroupBox1: TGroupBox;
    Button1: TButton;
    Button2: TButton;
    LabeledEdit1: TLabeledEdit;
    ComboBox1: TComboBox;
    Label1: TLabel;
    ColorBox1: TColorBox;
    Label2: TLabel;
    Button3: TButton;
    ComboBox2: TComboBox;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    combo_flagcolors: TComboBoxEx;
    Label6: TLabel;
    combo_folders: TComboBox;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure ListView1CustomDrawItem(Sender: TCustomListView;
      Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FiltersForm: TFiltersForm;

implementation

uses MainForm_FRM,misc;

{$R *.dfm}

procedure TFiltersForm.Button2Click(Sender: TObject);
begin
if listview1.SelCount>0 then
if MessageBox( Self.Handle,
PChar(TranslateString('Do you want to delete selected filter?')),PChar(TranslateString('Question')),                               MB_ICONQUESTION Or MB_YESNO )=IDYES then


listview1.Selected.Delete;
end;

procedure TFiltersForm.Button1Click(Sender: TObject);
begin
close;
end;

procedure TFiltersForm.FormShow(Sender: TObject);
var i : integer;
var feednum:feednumber;
begin
feednum:=feednumber.Create;
feednum.id:=0;
combobox2.items.Clear;
combo_folders.items.clear;
combobox2.additem(translatestring('Any of feeds'),feednum);
    For i := Low(gSubscribedFeeds) To High(gSubscribedFeeds) Do
        begin
        if gSubscribedFeeds[i].feedtype='http' then
        begin
        feednum:=feednumber.Create;
        feednum.id:=gSubscribedFeeds[i].feedid;
        combobox2.AddItem(gSubscribedFeeds[i].title,feednum);
        end;
        if gSubscribedFeeds[i].feedtype='localfeed' then
        begin
        feednum:=feednumber.Create;
        feednum.id:=gSubscribedFeeds[i].feedid;
        combo_folders.AddItem(gSubscribedFeeds[i].title,feednum);
        end;

        end;

combobox1.Clear;
combobox1.Items.Add(translatestring('Highlight'));
combobox1.Items.Add(translatestring('Delete'));
combobox1.Items.Add(translatestring('Set flag'));
combobox1.Items.Add(translatestring('Copy to...'));

combobox2.Itemindex:=0;
combobox1.Itemindex:=0;
combo_flagcolors.ItemIndex:=0;
if combo_folders.Items.Count>0 then combo_folders.ItemIndex:=0;
ComboBox1Change(sender);
TranslateForm(self);
for i:=0 to listview1.Columns.Count-1 do
begin
listview1.Columns[i].Caption:=translatestring(listview1.Columns[i].Caption);
end;
end;

procedure TFiltersForm.ComboBox1Change(Sender: TObject);
begin
colorbox1.visible:=(combobox1.ItemIndex=0);
label2.Visible:=(combobox1.ItemIndex=0);
combo_flagcolors.Visible:=(combobox1.ItemIndex=2);
label6.Visible:=(combobox1.ItemIndex=2);
combo_folders.Visible:=(combobox1.ItemIndex=3);
end;

procedure TFiltersForm.Button3Click(Sender: TObject);
  var InputString:string;
begin
if trim(labelededit1.text)='' then exit;
Inputstring:=labelededit1.text;
if not inputquery(translatestring('Filter name'), translatestring('Please enter name of filter'), inputstring) then exit;
if trim(inputstring)='' then exit;

with listview1.Items.Add do
  begin
  caption:=inputstring;
  subitems.Add(combobox2.Items[combobox2.itemindex]);
  data:=feednumber.create;
  feednumber(data).id:=feednumber(combobox2.items.Objects[combobox2.itemindex]).id;
  subitems.Add(labelededit1.text);
  feednumber(data).action:=combobox1.itemindex;
  subitems.Add(combobox1.Items[combobox1.itemindex]);

  if colorbox1.visible
    then
      begin
      subitems.Add(colorbox1.ColorNames[colorbox1.itemindex]);
      feednumber(data).option:=(colorbox1.itemindex);
      end
  else if combo_flagcolors.Visible
    then
      begin
      subitems.Add(combo_flagcolors.Items[combo_flagcolors.itemindex]);
      feednumber(data).option:=(combo_flagcolors.itemindex);

      end
  else if combo_folders.Visible
    then
      begin
      subitems.Add(combo_folders.Items[combo_folders.itemindex]);
      feednumber(data).option:=(combo_folders.itemindex);
      end
  else
    begin
    subitems.add('');
      feednumber(data).option:=-1;

    end;
  labelededit1.text:='';
  end;
end;

procedure TFiltersForm.ListView1CustomDrawItem(Sender: TCustomListView;
  Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
begin
  if (filtersform.ColorBox1.Items.IndexOf(item.subitems[1])<>-1) then listview1.Canvas.Font.Color:=filtersform.colorbox1.Colors[filtersform.ColorBox1.Items.IndexOf(item.subitems[1])];

end;

procedure TFiltersForm.FormCreate(Sender: TObject);
begin


//TranslateForm(self);
end;

end.
