(*
 *   FeedReader
 *   Copyright (C) 2003 The FeedReader Developement Group
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *)
unit ImportOPMLForm_FRM;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, xfunctions,ComCtrls, ExtCtrls, xdom_2_3, httpprot, misc,
  languagesupport;

  
type
  opmlitem = class
    name,
    description,
    xmlurl,
    htmlurl: string;
  end;
  
type
  TImportOPMLForm = class(TForm)
    edt_opmlurl: TLabeledEdit;
    Label1: TLabel;
    lv_opml: TListView;
    btn_opmlimport: TButton;
    btn_cancel: TButton;
    btn_addfeeds: TButton;
    btn_select: TButton;
    btn_browse: TButton;
    OpenDialog1: TOpenDialog;
    combobox_folder: TComboBox;
    Label2: TLabel;
    btn_setfilefolder: TButton;
    btn_unselect: TButton;
    statuspanel: TPanel;
    Label15: TLabel;
    ProgressBar1: TProgressBar;
    procedure btn_opmlimportClick(Sender: TObject);
    procedure btn_cancelClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btn_addfeedsClick(Sender: TObject);
    procedure btn_selectClick(Sender: TObject);
    procedure RefreshFeedListFromProvider_OnHeaderData(Sender: TObject);
    procedure RefreshFeedListFromProvider_OnDocData(Sender: TObject; Buffer: Pointer; Len: Integer);
    procedure RefreshFeedListFromProvider_OnRequestDone(Sender: TObject; RqType: THttpRequest; Error: Word);
    procedure btn_browseClick(Sender: TObject);
    procedure Formshow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure edt_opmlurlChange(Sender: TObject);
    procedure btn_setfilefolderClick(Sender: TObject);
    procedure lv_opmlClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ImportOPMLForm: TImportOPMLForm;

implementation

uses MainForm_FRM, FReaderProperties;

{$R *.dfm}

procedure TImportOPMLForm.btn_opmlimportClick(Sender: TObject);
var
  DomImplementation: tdomimplementation;
  XmlToDomParser: txmltodomparser;
  domdoc: tdomdocument;
  http: thttpcli;
  i, jjj: integer;
  li: tlistitem;
  n:ttreenode;
  attribuudid: tdomnamednodemap;
  found,alreadysubscribed: boolean;
  elemendid: tdomnodelist;
  element, atrnode1, atrnode, atrnode2, atrnode3, atrnode4, attrnode5: tdomnode;
  TmpElement: TdomNode;
  ResponseStream: TStream;
  RDFType: Integer;
  Count: Integer;
  Categoryname:string;

begin
  if trim(edt_opmlurl.Text) = '' then
    exit;
btn_unselect.enabled:=false;
btn_unselect.enabled:=true;
btn_addfeeds.Enabled:=false;
combobox_folder.enabled:=false;
  lv_opml.items.Clear;
  lv_opml.tag:=0;
  ResponseStream := Nil;
  DomImplementation := Nil;
  XmlToDomParser := Nil;
  DomImplementation := TDomImplementation.Create(nil);
  XmlToDomParser := TXmlToDomParser.Create(nil);
  Xmltodomparser.DOMImpl := DomImplementation;

  if not fileexists(edt_opmlurl.Text) then
    begin
    http := THttpCli.Create(Nil);
    ResponseStream := TMemoryStream.Create;

    InitHttpClientProxySettings( http );
    http.URL := trim(edt_opmlurl.Text);
    http.RcvdStream := ResponseStream;
    http.onheaderdata := RefreshFeedListFromProvider_OnHeaderData;
    http.ondocdata := RefreshFeedListFromProvider_OnDocData;
    http.OnRequestDone := RefreshFeedListFromProvider_OnRequestDone;
    label15.Caption := TranslateString('Downloading feedlist');
    label15.Refresh;

    http.Get;
    If http.StatusCode <> 200 Then
      Raise Exception.Create( http.LastResponse );

    progressbar1.position := 0;
    label15.Caption := TranslateString('Parsing feedlist');
    label15.Refresh;

    http.Rcvdstream.Position := 0;
    domdoc := XmlToDomParser.streamToDom( http.RcvdStream );
    // free the memory, some lists are very large >4MB
    FreeAndNil( http );
    FreeAndNil( ResponseStream );
    end
  else
   domdoc := XmlToDomParser.fileToDom(edt_opmlurl.text);

  elemendid := domdoc.getElementsByTagName('outline');
  if elemendid.length>0 then begin
  btn_unselect.enabled:=false;
  btn_setfilefolder.enabled:=false;
  btn_select.enabled:=true;
  btn_addfeeds.Enabled:=false;
  end;
  ProgressBar1.Max:=elemendid.length;
  for i:=0 to elemendid.length-1 do
  begin
    ProgressBar1.Position:=i;
    application.ProcessMessages;
    attribuudid := elemendid.item(i).attributes;
    if elemendid.item(i).parentNode.nodeName='body' then categoryname:='';
    atrnode1 := attribuudid.getNamedItem('text');
    {
      Newsgator uses 'title' instead of 'text'.
    }
    if (attribuudid.getNamedItem('title')<>nil) and (attribuudid.length=1) then Categoryname:=attribuudid.getNamedItem('title').textcontent;
    if (atrnode1 = nil) then atrnode1 := attribuudid.getNamedItem('title');
    atrnode2 := attribuudid.getNamedItem('description');
    atrnode3 := attribuudid.getNamedItem('xmlUrl');
    if atrnode3=nil then atrnode3 := attribuudid.getNamedItem('xmlURL');
    atrnode4 := attribuudid.getNamedItem('htmlUrl');

    if (atrnode1<>nil) and (atrnode3<>nil) and (trim(atrnode1.textcontent)<>'') and (trim(atrnode3.textContent)<>'') then
    begin
    //first we have to find if feed is already subscribed
      alreadysubscribed:=false;
      n := gMyFeedsTreeNode.getFirstChild;
      while (n <> nil) and (n.data <> nil) and (n.Level > 0) do
      begin
        if Tfeedinfo(n.Data).link = xfunctions.unescapehtml(atrnode3.textContent) then
        begin
        alreadysubscribed:=true;
        break;
        end;
        n := n.GetNext;
      end;


    //end of search
      with lv_opml.Items.Add do
      begin
        data:=opmlitem.Create;
        opmlitem(data).name:=UnEscapeHTML(atrnode1.textContent);
        if atrnode2<>nil then opmlitem(data).description:=atrnode2.textContent;
        opmlitem(data).xmlurl:=xfunctions.unescapehtml(atrnode3.textContent);
        if (atrnode4 <> nil) then opmlitem(data).htmlurl := unescapehtml(atrnode4.textContent);
        if alreadysubscribed then caption:='<'+translatestring('already subscribed')+'>' else caption:='<'+translatestring('no import')+'>';
        if atrnode1<>nil then subitems.add(UnEscapeHTML(atrnode1.textContent)) else subitems.add('No name');
        subitems.add(UnEscapeHTML(categoryname));
        if atrnode2<>nil then subitems.Add(UnEscapeHTML(atrnode2.textContent));
        if (combobox_folder.Items.IndexOf(categoryname)>-1) and not alreadysubscribed then caption:=categoryname;
      end;
    end;
  end;
  progressbar1.Position:=0;
  Label15.Caption:=inttostr(elemendid.length)+' '+translatestring('feeds imported');
end;

procedure TImportOPMLForm.btn_cancelClick(Sender: TObject);
begin
  close;
end;

procedure TImportOPMLForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  mainwindow.enabled:=true;
  Action := caFree;
end;

procedure TImportOPMLForm.btn_addfeedsClick(Sender: TObject);
//add selected feeds to "my feeds" folder
var i,totalcount:integer;
var targetnode,n,newitem:ttreenode;
    parenttype:string;
begin

//  if targetnode=nil then targetnode:=MainForm_FRM.gMyFeedsTreeNode;
  totalcount:=0;
  progressbar1.max:=lv_opml.Items.Count;
  for i:=0 to lv_opml.Items.Count-1 do if lv_opml.Items.Item[i].Checked and (lv_opml.items.item[i].caption<>'<'+translatestring('no import')+'>') and (lv_opml.items.item[i].caption<>'<'+translatestring('already subscribed')+'>') then
  begin
    progressbar1.position:=i;
    targetnode := nil;
    parenttype:='';
    //we have to have delay here for every feed to get unique id
    sleep(100);
    //Here we have to find folder for feed
    if (lv_opml.Items.Item[i].caption=translatestring('Beginning of My feeds')) or (lv_opml.Items.Item[i].caption=translatestring('End of My feeds')) then targetnode:=MainForm_FRM.gMyFeedsTreeNode
    else begin
      n := gMyFeedsTreeNode.getFirstChild;
      while (n <> nil) and (n.data <> nil) and (n.Level > 0) do
      begin
        if Tfeedinfo(n.Data).tiitel = lv_opml.items.Item[i].caption then
        begin
        targetnode:=n;
        parenttype:='folder';
        break;
        end;
        n := n.GetNext;
      end;

    end;
    //end finding folder
    totalcount:=totalcount+1;
    if (lv_opml.Items.Item[i].caption=translatestring('Beginning of My feeds')) then newitem:=mainwindow.treeview1.Items.AddChildFirst(targetnode, opmlitem(lv_opml.Items.Item[i].data).name)
    else newitem:=mainwindow.treeview1.Items.addchild(targetnode, opmlitem(lv_opml.Items.Item[i].data).name);
    with newitem do
    begin
      data := Tfeedinfo.create;
      Tfeedinfo(data).feedid := strtofloat(floattostr(TimeStampToMSecs(DateTimeToTimeStamp(now))+i));
      Tfeedinfo(data).id := gMyFeedsTreeNode.Count + 10 + 1;
      Tfeedinfo(data).link := opmlitem(lv_opml.Items.Item[i].data).xmlurl;
      Tfeedinfo(data).description := opmlitem(lv_opml.Items.Item[i].data).description;
      Tfeedinfo(data).htmlurl := opmlitem(lv_opml.Items.Item[i].data).htmlurl;
      if (pos('news://', opmlitem(lv_opml.Items.Item[i].data).xmlurl) > 0) or (pos('ext://', opmlitem(lv_opml.Items.Item[i].data).xmlurl) > 0) then
        Tfeedinfo(data).feedtype := 'ext'
      else
        Tfeedinfo(data).feedtype := 'http';
      Tfeedinfo(data).tiitel := opmlitem(lv_opml.Items.Item[i].data).name;
      Tfeedinfo(data).updateperiod := DefaultFeedRefreshIdValue;
      Tfeedinfo(data).ArchiveSize := DefaultArchiveSizeIdValue;
      try
      get_fav_icon(trim(tfeedinfo(newitem.data).link));
      newitem.imageindex:=insertfavicon(trim(tfeedinfo(newitem.data).link));
      newitem.selectedindex:=newitem.imageindex;
      except
      end;


      EnterCriticalSection(gCritSect);
      try
        SetLength( gSubscribedFeeds, Length(gSubscribedFeeds) + 1 );
        gSubscribedFeeds[ Length(gSubscribedFeeds)-1 ].unreadcount := '0';
        gSubscribedFeeds[ Length(gSubscribedFeeds)-1 ].feedtype := Tfeedinfo(data).feedtype;
        gSubscribedFeeds[ Length(gSubscribedFeeds)-1 ].parent := parenttype;
        gSubscribedFeeds[ Length(gSubscribedFeeds)-1 ].link := opmlitem(lv_opml.Items.Item[i].data).xmlurl;
        gSubscribedFeeds[ Length(gSubscribedFeeds)-1 ].title := opmlitem(lv_opml.Items.Item[i].data).name;
        gSubscribedFeeds[ Length(gSubscribedFeeds)-1 ].description := opmlitem(lv_opml.Items.Item[i].data).description;
        gSubscribedFeeds[ Length(gSubscribedFeeds)-1 ].updateperiod := DefaultFeedRefreshIdValue;
        gSubscribedFeeds[ Length(gSubscribedFeeds)-1 ].unread := '0';
        gSubscribedFeeds[ Length(gSubscribedFeeds)-1 ].feedid := Tfeedinfo(data).feedid;
        gSubscribedFeeds[ Length(gSubscribedFeeds)-1 ].ArchiveSize := DefaultArchiveSizeIdValue;
        gSubscribedFeeds[ Length(gSubscribedFeeds)-1 ].htmlurl := opmlitem(lv_opml.Items.Item[i].data).htmlurl;
      finally
        LeaveCriticalSection(gCritSect);
      end;
    end;
  end;
  targetnode.Expand(false);
  if totalcount>0 then
    MessageBox( Application.Handle,
                PChar(inttostr(totalcount)+' '+TranslateString('feeds successfully added')),
                PChar(TranslateString('Information')),
                MB_OK or MB_ICONINFORMATION);
    progressbar1.position:=0;
end;

procedure TImportOPMLForm.btn_selectClick(Sender: TObject);
var
  i: integer;
begin
  //check or uncheck all items of listview
  for i := 0 to lv_opml.items.Count-1 do
    if sender=btn_select then
      lv_opml.items.item[i].Checked := true
    else lv_opml.items.item[i].Checked := false;
if sender=btn_select then btn_unselect.Enabled:=true;
if sender=btn_select then combobox_folder.Enabled:=true;
if sender=btn_unselect then btn_unselect.Enabled:=false;
btn_addfeeds.Enabled:=btn_unselect.enabled;
btn_setfilefolder.Enabled:=btn_unselect.enabled;
end;

procedure TImportOPMLForm.RefreshFeedListFromProvider_OnHeaderData(Sender: TObject);
begin
  if pos('Content-Len', thttpcli(sender).LastResponse) > 0 then
    progressbar1.max := strtoint(stringreplace(thttpcli(sender).LastResponse, 'Content-Length: ', '', []));
end;

procedure TImportOPMLForm.RefreshFeedListFromProvider_OnDocData(Sender: TObject; Buffer: Pointer; Len: Integer);
begin
  progressbar1.position := thttpcli(sender).RcvdCount;
end;

procedure TImportOPMLForm.RefreshFeedListFromProvider_OnRequestDone(Sender: TObject; RqType: THttpRequest; Error: Word);
begin
  if (error = 0) and (thttpcli(sender).StatusCode = 404) then begin
    mainwindow.progressbar1.Position := 0;
    showmessage( TranslateString('OPML not found') );
  end;
end;

procedure TImportOPMLForm.btn_browseClick(Sender: TObject);
begin

if opendialog1.execute then edt_opmlurl.text:=opendialog1.FileName;
end;

procedure TImportOPMLForm.Formshow(Sender: TObject);
var n:ttreenode;
begin
edt_opmlurl.SetFocus;
ComboBox_folder.Items.clear;
Combobox_folder.items.add(translatestring('Beginning of My feeds'));
Combobox_folder.items.add(translatestring('End of My feeds'));

  n := gMyFeedsTreeNode.getFirstChild;
    while (n <> nil) and (n.data <> nil) and (n.Level > 0) do
    begin
      if Tfeedinfo(n.Data).feedtype = 'folder' then
      begin
              if ComboBox_folder.Items.count=0 then Combobox_folder.items.add(translatestring('My feeds'));
              ComboBox_folder.Items.AddObject( Tfeedinfo(n.data).tiitel, n.data );
      end;
      n := n.GetNext;
    end;
//Combobox_folder.visible:=(ComboBox_folder.Items.count>0);

label2.visible:=(ComboBox_folder.Items.count>0);
combobox_folder.itemindex:=1;
//  edt_opmlurl.setfocus;
end;

procedure TImportOPMLForm.FormCreate(Sender: TObject);
begin
  TranslateForm(self);
  edt_opmlurl.EditLabel.Caption := TranslateString(edt_opmlurl.EditLabel.Caption);

  lv_opml.Columns[0].Caption := TranslateString(lv_opml.Columns[0].Caption);
  lv_opml.Columns[1].Caption := TranslateString(lv_opml.Columns[1].Caption);
  lv_opml.Columns[2].Caption := TranslateString(lv_opml.Columns[2].Caption);


end;

procedure TImportOPMLForm.edt_opmlurlChange(Sender: TObject);
begin
btn_opmlimport.enabled:=(trim(edt_opmlurl.text)<>'');
end;

procedure TImportOPMLForm.btn_setfilefolderClick(Sender: TObject);
var i:integer;
begin
for i:=0 to lv_opml.Items.Count-1 do
begin
if lv_opml.Items[i].Checked then lv_opml.Items[i].Caption:=combobox_folder.Text;
end;
lv_opmlClick(sender);
end;

procedure TImportOPMLForm.lv_opmlClick(Sender: TObject);
var i:integer;
begin
btn_unselect.enabled:=false;
btn_addfeeds.enabled:=false;
for i:=0 to lv_opml.Items.Count-1 do
begin
if lv_opml.Items[i].Checked and not btn_unselect.enabled then btn_unselect.enabled:=true;
if lv_opml.Items[i].Checked and ((lv_opml.items[i].Caption<>'<'+translatestring('already subscribed')+'>') and (lv_opml.items[i].Caption<>'<'+translatestring('no import')+'>')) and not btn_addfeeds.enabled then btn_addfeeds.Enabled:=true;

end;

btn_setfilefolder.Enabled:=btn_unselect.enabled;
combobox_folder.enabled:=btn_setfilefolder.Enabled;
end;

end.
