(*
 *   FeedReader
 *   Copyright (C) 2003 The FeedReader Developement Group
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *)

procedure TMainWindow.actAddNewFeedExecute(Sender: TObject);
//Add new external feed
var
  n:ttreenode;
  SelectedFolder: string;
  ParentNode: TTreeNode;
begin
  if treeview1.selected=nil then gmyfeedstreenode.selected:=true;
  AddNewFeedForm.ComboBox_folder.Items.clear;
  n := gMyFeedsTreeNode.getFirstChild;
  SelectedFolder := '';
  while (n <> nil) and (n.data <> nil) and (n.Level > 0) do
  begin
    if Tfeedinfo(n.Data).feedtype = 'folder' then
    begin
      if (TreeView1.Selected = n) then SelectedFolder := Tfeedinfo(n.data).tiitel;
      if AddNewFeedForm.ComboBox_folder.Items.count=0 then AddNewFeedForm.Combobox_folder.items.add(' ');
      AddNewFeedForm.ComboBox_folder.Items.AddObject( Tfeedinfo(n.data).tiitel, n.data );
    end;
    n := n.GetNext;
  end;
  if (SelectedFolder = '') then
  begin
    if TreeView1.selected.level=1 then SelectedFolder:=TranslateString('My feeds');
  end;
  if (SelectedFolder = '') then
  begin
    if NodeIsChildOf(TreeView1.Selected, gMyFeedsTreeNode) then
    begin
      ParentNode := TreeView1.Selected.Parent;
      while (SelectedFolder = '') and Assigned(ParentNode) do
      begin
        if (Tfeedinfo(ParentNode.Data).feedtype = 'folder') then
        begin
          SelectedFolder := Tfeedinfo(ParentNode.Data).tiitel;
        end
        else
        begin
          ParentNode := ParentNode.Parent;
        end;
      end;
    end;
  end;
  if (SelectedFolder <> '') then
  begin
    if (AddNewFeedForm.ComboBox_folder.Items.IndexOf(SelectedFolder) <> -1) then
      AddNewFeedForm.ComboBox_folder.ItemIndex := AddNewFeedForm.ComboBox_folder.Items.IndexOf(SelectedFolder)
    else
      AddNewFeedForm.ComboBox_folder.ItemIndex := -1;
  end;

  AddNewFeedForm.Combobox_folder.visible:=(AddNewFeedForm.ComboBox_folder.Items.count>0);
  AddNewFeedForm.label7.visible:=(AddNewFeedForm.ComboBox_folder.Items.count>0);
  AddNewFeedForm.edit3.text := '';
  AddNewFeedForm.CheckBox1.Visible := false;
  AddNewFeedForm.CheckBox1.checked := false;
  AddNewFeedForm.un.clear;
  AddNewFeedForm.pw.clear;
  AddNewFeedForm.Panel1.BringToFront;
  MainWindow.Enabled := false;
  AddNewFeedForm.Show;
end;


procedure TMainWindow.actSubscribeExecute(Sender: TObject);
begin
  //Subscribe to feed
  if treeview1.selected = nil then
    exit;
  if treeview1.Selected.Level < 2 then
    exit;

  if treeview1.Selected.Data = nil then
    exit;

  actAddNewFeed.Execute;
  AddNewFeedForm.CheckBox1.Visible := false;
  AddNewFeedForm.edit3.text := Tfeedinfo(treeview1.Selected.Data).link;
  AddNewFeedForm.Button1Click(Sender);
end;


procedure TMainWindow.actAboutExecute(Sender: TObject);
Var
  Dlg: TAboutDialog;
begin
  (*
  //splash.OnCreate:=FormCreate;
  splash := tsplashscreen.create(MainWindow);
  splash.Button1.Caption := TranslateString(splash.Button1.Caption);
  splash.borderstyle := bsToolWindow;
  splash.height := splash.Height + 25;
  splash.width := splash.width + 5;
  splash.Button1.Visible := true;
  splash.show;
  *)

  Dlg := TAboutDialog.Create( Self );
  Try
    Dlg.ShowModal;
  Finally
    Dlg.Free;
  End;
end;


procedure TMainWindow.actMarkAllHeadlinesAsReadExecute(Sender: TObject);
var
  i: integer;
  Idx: Integer;
  Idx2: Integer;
  walknode:ttreenode;
begin
  //Mark all articles in active feed as read
     //SendEmail('tom@trip.ee',' _subject',' _body : string', handle);
     //Siin mrgime kik mingi feedi all olevad uudised loetuks
  if treeview1.Selected = gAvailableFeedsTreeNode then
    exit;
  if (treeview1.selected.level = 1) and (treeview1.Selected.Parent <>
    gMyFeedsTreeNode) then
    exit;
  if (treeview1.selected.level = 2) and (treeview1.Selected.parent.Parent <>
    gMyFeedsTreeNode) then
    exit;

  if treeview1.selected <> gMyFeedsTreeNode then
  begin
    if Tfeedinfo(treeview1.Selected.Data).feedtype = 'folder' then
    begin
    walknode:=treeview1.selected.getfirstchild;
    while walknode<>nil do
      begin
          Idx := GetHeadlineIndex(true,Tfeedinfo(walknode.data).feedid, '', '', 0);
          while Idx > -1 do begin
          Repeat
          Idx2 := GetHeadlineIndex(true,0, theadline(gHeadlines[Idx]).tiitel, theadline(gHeadlines[Idx]).link, 0);
          if Idx2 > -1 Then Begin
            theadline(gHeadlines[Idx2]).Read := 1;
          End;
        Until Idx2 <= -1;

        Idx := GetHeadlineIndex(true,Tfeedinfo(walknode.data).feedid, '', '', 0);
      end;
      walknode:=walknode.getnextsibling;
      end;
    RecalcUnreadStatus;
    TreeView1Click(sender);
    exit;
    end;


    if (treeview1.Selected.Parent = gMyFeedsTreeNode) or
      (treeview1.Selected.Parent.parent = gMyFeedsTreeNode) then
    begin
      Idx := GetHeadlineIndex(true,Tfeedinfo(treeview1.Selected.data).feedid, '', '', 0);
      while Idx > -1 do begin

        Repeat
          Idx2 := GetHeadlineIndex(true,0, theadline(gHeadlines[Idx]).tiitel, theadline(gHeadlines[Idx]).link, 0);
          if Idx2 > -1 Then Begin
            theadline(gHeadlines[Idx2]).Read := 1;
          End;
        Until Idx2 <= -1;

        Idx := GetHeadlineIndex(true,tfeedinfo(treeview1.Selected.data).feedid, '', '', 0);
      end;

      fillview(treeview1.selected, true);
    end;
  end
  else
  begin
    //gMyFeedsTreeNode is selected
    for i := 0 to gHeadlines.count - 1 do
      theadline(gHeadlines[i]).read := 1;
  end;

  RecalcUnreadStatus;
  TreeView1Click(sender);
end;


procedure TMainWindow.actCreateNewFolderExecute(Sender: TObject);
var
  fn: string;
begin
  //Create new folder
  fn := InputBox( TranslateString('Create new folder'), TranslateString('Folder name'), '');
  if fn = '' then
    exit;
  with treeview1.Items.AddChild(gMyFeedsTreeNode, fn) do
  begin
    data := Tfeedinfo.Create;
    Tfeedinfo(data).tiitel := fn;
    Tfeedinfo(data).feedtype := 'folder';
    imageIndex := 1;
    SelectedIndex := 1;

  end;
end;

procedure TMainWindow.actDeleteFolderExecute(Sender: TObject);
var i:integer;
feedid:real;
begin
  //Delete folder

  if treeview1.Selected = nil then exit;
  if treeview1.selected.parent = nil then exit;
  if treeview1.selected.level < 1 then exit;

  if not NodeIsChildOf(treeview1.selected,gMyFeedsTreeNode) then exit;
  if treeview1.selected.HasChildren then
  begin
    showmessage( TranslateString('This folder contains feeds')+'. '+TranslateString('Please delete all feeds in this folder first')+'.');
    exit;
  end;
  if MessageDlg( TranslateString('Do you want to delete active folder?'), mtinformation, [mbOk,
    mbcancel], 0) <> mrcancel then
    begin
      treeview1.selected.delete;
    end;

end;

procedure TMainWindow.actCopyToFolderExecute(Sender: TObject);
begin
end;


procedure TMainWindow.actAquaraiumViewExecute(Sender: TObject);
begin
  //Resize minibrowser window
  LockWindowUpdate(MainWindow.Handle);
  MainWindow.Canvas.Lock;
  try
    if (panel1.tag = 0) and (flatpanel2.tag = 0) then
    begin
      panel1.Tag := panel1.height;
      panel1.height := 0;
      splitter1.Height := 0;
      splitter2.width := 0;

      flatpanel2.Tag := flatpanel2.width;
      flatpanel2.width := 0;
      navpanel.visible := true;

      link.Width := navpanel.Width - link.Left - 5 - imgWebNavGo.width;
      imgWebNavGo.Left := link.width + link.left + 2;
    end
    else
    begin
      panel1.Height := panel1.Tag;
      splitter1.Height := 3;
      panel1.tag := 0;
      flatpanel2.width := flatpanel2.tag;
      splitter2.width := 3;
      flatpanel2.tag := 0;
      navpanel.visible := false;
    end;
  except
  end;
  MainWindow.Canvas.unLock;
  LockWindowUpdate(0);

end;


procedure TMainWindow.actCreateNewLocalFeedExecute(Sender: TObject);
var
  fn: string;
begin
  //Create new local feed
  fn := InputBox( TranslateString('Create new local feed'), TranslateString('Local feed name'), '');
  if fn = '' then
    exit;
  with treeview1.Items.AddChild(gMyFeedsTreeNode, fn) do
  begin
    data := Tfeedinfo.Create;
    Tfeedinfo(data).feedid :=
      strtofloat(floattostr(TimeStampToMSecs(DateTimeToTimeStamp(now))));
    Tfeedinfo(data).id := gMyFeedsTreeNode.Count + 10 + 1;
    Tfeedinfo(data).tiitel := fn;
    Tfeedinfo(data).feedtype := 'localfeed';

    imageindex := 28;
    selectedindex := 28;

  end;

end;

procedure TMainWindow.actShowWindowExecute(Sender: TObject);
begin
  if self.Visible then
  begin
    application.bringtofront;
  SetForegroundWindow(Self.Handle);
  BringWindowToTop(Self.Handle);
 exit;
end;
  AnimateTrayIcon( False );
  if MainWindow.WindowState = wsminimized then
    MainWindow.WindowState := ws;
  CoolTrayIcon1.ShowMainForm;
  application.restore;
  application.bringtofront;
  SetForegroundWindow(Self.Handle);
  BringWindowToTop(Self.Handle);
end;

procedure TMainWindow.actGotoNextUnreadExecute(Sender: TObject);
var
  node, an: ttreenode;
  i, j, times: integer;
  num: real;
  cancel:boolean;

  begin
  times:=0;
  //Go to next unread article
  j := GetHeadlineIndex(true,0, '', '', 0);
  if j = -1 then
  begin
    MessageBox( Self.Handle,
                PChar(TranslateString('There are no unread messages') ),
                PChar(TranslateString('All read')),
                MB_ICONINFORMATION Or MB_ok );
    exit;
  end;
  node:=treeview1.selected;
  if NodeIsChildOf(node, gsmartviewsTreeNode) or (node.level=0) then
    begin
    node:=gmyfeedstreenode.getfirstchild;
    end;
  Cancel := false;
  repeat
    j := GetHeadlineIndex(true,Tfeedinfo(node.data).feedid, '', '', 0);
    node:=node.getnext;
    if (node=nil) or (node.level=0) then
    begin
    node:=gmyfeedstreenode.getfirstchild;
    inc(times);
    end;
    if (j=-1) and (GetHeadlineIndex(true,Tfeedinfo(node.data).feedid, '', '', 0)>-1) then
    begin
      if (not gProperties.AutoJumpToNextUnreadNextFeed) then
        Cancel := IDYES <> MessageBox( Self.Handle,
                                       PChar(TranslateString('Advance to next unread message in '+trim(node.text)+'?') ),
                                       PChar(TranslateString('Next unread')),
                                       MB_ICONQUESTION Or MB_YESNO );
    end;
    if cancel then exit;
  until (j>-1) or (times>2);
//"times" variable is for workaround if there are some unread messages in database but somehow owners of these messages are goneni
  if times>2 then
    begin
    MessageBox( Self.Handle,
                PChar(TranslateString('There are no unread messages') ),
                PChar(TranslateString('All read')),
                MB_ICONINFORMATION Or MB_ok );
    exit;
    end;
  num := theadline(gHeadlines[j]).owner;

  node := nil;
  //Siin hakkame otsast otsima unread messageid
  an := gMyFeedsTreeNode.getFirstChild;
  while (an<>nil) and (an.level > 0) do
  begin
    if Tfeedinfo(an.data).feedid = num then
    begin
      node := an;
      break;
    end;
    an := an.GetNext;
  end;
  if node <> nil then
  begin
    NODE.Selected := true;
    for i := 0 to listview1.Items.Count - 1 do
    begin
      if theadline(listview1.Items[i].Data).read = 0 then
      begin
        ListView1.ItemFocused := ListView1.Items[i];
        listview1.Items[i].Selected := true;
//        if i<listview1.items.count-1 then
//          listview1.items[i+1].makevisible(false)
//        else
          listview1.items[i].makevisible(false);
        ListView1.Tag := 1;
        ListView1Click(sender);
        break;
      end;
    end;
  end;
end;


procedure TMainWindow.actNewsOverviewExecute(Sender: TObject);

  Function FeedIdToString( FeedID: Real; Var FeedName: String ): Boolean;
  Var
    j: Integer;
  Begin
    For j := 0 To Length(gSubscribedFeeds)-1 Do
      If gSubscribedFeeds[j].feedid = FeedID Then Begin
        FeedName := gSubscribedFeeds[j].title;
        Result := True;
        Exit;
      End;

    FeedName := '** Unknown **';
    Result := False;
  End;


  Function CompareItems( I1, I2: Integer ): Integer;
  Var
    Date1, Date2: TDateTime;
    FeedName1, FeedName2: String;
  Begin
    Date1 := XX_DecodeDate( theadline(gHeadlines[I1]).date );
    Date2 := XX_DecodeDate( theadline(gHeadlines[I2]).date );

    // sort by date
    If (Date1 > Date2) Then Result := -1
    Else if (Date1 < Date2) Then Result := 1
    Else Begin
      // now sort by owner
      FeedIdToString(theadline(gHeadlines[I1]).owner, FeedName1);
      FeedIdToString(theadline(gHeadlines[I2]).owner, FeedName2);
      Result := CompareText( FeedName1, FeedName2 );
      If Result = 0 Then
      Begin
        // now sort by headline-id
        If (theadline(gHeadlines[I1]).hlid > theadline(gHeadlines[I2]).hlid) Then Result := 1
        Else If (theadline(gHeadlines[I1]).hlid < theadline(gHeadlines[I2]).hlid) Then Result := -1
        Else
        Result := 0;
      End;
    End;
  End;

    procedure QuickSort(L, R: Integer);
  var
    I, J: Integer;
    T: THeadline;
    P: Integer;
  begin
    t:=theadline.create;
    repeat
      I := L;
      J := R;
      P := (L + R) shr 1;
      repeat
        while CompareItems(I, P) < 0 do
          Inc(I);
        while CompareItems(J, P) > 0 do
          Dec(J);
        if I <= J then
        begin
          T := theadline(gHeadlines[I]);
          gHeadlines[I] := gHeadlines[J];
          gHeadlines[J] := T;
          Inc(I);
          Dec(J);
        end;
      until I > J;
      if L < J then
        QuickSort(L, J);
      L := I;
    until I >= R;
  end;

  procedure FillAllowedFeedsList(var AllFeeds: boolean; const AllowedFeeds: TStringList);
  var
    ParentNode: TTreeNode;
    i: integer;
    FeedInfo: Tfeedinfo;
  begin
    {
      Get the actual node. If it is a feed, write the ID in the list.
      If it is a folder, write all items in this folder into the list.
      If it is the MyFeeds-Node, write all subscribed feeds to the list.
    }
    {
      First get a valid parent node.
    }
    if (TreeView1.Selected = nil) then
      ParentNode := gMyFeedsTreeNode
    else
    begin
      if (not NodeIsChildOf(TreeView1.Selected, gMyFeedsTreeNode)) then
        ParentNode := gMyFeedsTreeNode
      else
        ParentNode := TreeView1.Selected;
    end;
    if (ParentNode = gMyFeedsTreeNode) then
      AllFeeds := true
    else
    begin
      AllFeeds := false;
      FeedInfo := Tfeedinfo(ParentNode.Data);
      if (Tfeedinfo(ParentNode.data).feedtype = 'folder') then
      begin
        if ParentNode.HasChildren then
        begin
          for i := 0 to ParentNode.Count-1 do
          begin
            AllowedFeeds.Add(FloatToStr(Tfeedinfo(ParentNode.Item[i].Data).feedid));
          end;
        end;
      end
      else
      begin
        AllowedFeeds.Add(FloatToStr(FeedInfo.feedid));
      end;
    end;
  end;
  
Var
  St: TStringStream;
  i: Integer;
  CurDate: TDateTime;
  CurOwner: Real;
  HLDate: TDateTime;
  fNeedDivider: Boolean;
  fOnlyUnread: Boolean;
  NewsCount: Integer;
  FeedName: String;
  AllowAllFeeds: boolean;
  AllowedFeeds: TStringList;
Begin
  Screen.Cursor := crHourglass;
  Application.ProcessMessages;
  try
    AllowedFeeds := TStringList.Create;
    fOnlyUnread := True;

    EnterCriticalSection( gCritSect );
    Try
      If gHeadlines.count > 0 Then
        Misc.Sortheadlines(gHeadlines);
    Finally
      LeaveCriticalSection( gCritSect );
    End;

    FillAllowedFeedsList(AllowAllFeeds, AllowedFeeds);

    St := TStringStream.Create( '' );
    Try

      NewsCount := 0;
      CurOwner := -1;
      CurDate := EncodeDate( 1970, 1, 1 );
      fNeedDivider := False;

      St.WriteString( '<HTML>'#13#10 +
                      '<HEAD>'#13#10 +
                      '<TITLE>News</TITLE>'#13#10 +
                          '<style type="text/css">'#13#10 +
                          '<!--'#13#10 +
                          '#dateHeader {  color: white; background-color:#c0c0c0; font-weight: bold; font-size:12pt; }'#13#10 +
                          '#feedHeader {  color: black; background-color:#e0e0e0; font-weight: bold; font-size:10pt; }'#13#10 +
                          '#headlineHeader { color: black; font-size:8pt; }'#13#10 +
                          '#headlineBody { color: black;; font-size:8pt; }'#13#10 +
                          'a:active  {  color: blue;      text-decoration: underline; }'#13#10 +
                          'a:hover   {  color: blue;      text-decoration: none; }'#13#10 +
                          'a:link    {  color: blue;      text-decoration: underline; }'#13#10 +
                          'a:visited {  color: blue;      text-decoration: underline; }'#13#10 +
                          'body {  background-color:white; font-family: verdana,arial,helvetica,sans-serif; font-size:8pt;}'#13#10 +
                          '-->'#13#10 +
                          '</style>'#13#10 +
                      '</HEAD>'#13#10+
                      '<BODY>'#13#10 );

      St.WriteString( '<TABLE width="100%">' );


      For i := 0 To gHeadlines.count-1 Do Begin
        Application.ProcessMessages;
        if theadline(gHeadlines[i]).deleted Then
          Continue;

        If fOnlyUnread Then
          if theadline(gHeadlines[i]).Read = 1 Then
            Continue;


        if (not AllowAllFeeds) and (AllowedFeeds.IndexOf(FloatToStr(theadline(gHeadlines[i]).owner)) = -1) then
          Continue;

        If CurOwner <> theadline(gHeadlines[i]).owner Then
          If Not FeedIdToString( theadline(gHeadlines[i]).owner, FeedName ) Then
            Continue;

        Inc(NewsCount);

        HLDate := XX_DecodeDate( theadline(gHeadlines[i]).date );
        If CurDate <> HLDate Then
        Begin
          If fNeedDivider Then St.WriteString( '<tr><td>&nbsp;</td></tr>' );
          CurDate := HLDate;
          St.WriteString( '<TR><TD width="100%" ID=dateHeader>' + FormatDateTime( LongDateFormat, CurDate) + '</TD></TR>'#13#10 );
          fNeedDivider := False;
        End;


        If CurOwner <> theadline(gHeadlines[i]).owner Then
        Begin
          CurOwner := theadline(gHeadlines[i]).owner;

          If fNeedDivider Then St.WriteString( '<tr><td>&nbsp;</td></tr>' );
          St.WriteString( '<TR><TD width="100%" ID=feedHeader>' + FeedName + '</TD></TR>'#13#10 );
          fNeedDivider := False;
        End;


        If fNeedDivider Then Begin
          St.WriteString( '<tr><td>' );
            St.WriteString( '<hr>' );
          St.WriteString( '</td></tr>' );
        End;


        St.WriteString( '<tr><td width="100%" id=headlineHeader>' );
          if Length(theadline(gHeadlines[i]).link) > 0 Then
            St.WriteString( '<A href="' + theadline(gHeadlines[i]).link + '">');
          St.WriteString( theadline(gHeadlines[i]).tiitel );
          if Length(theadline(gHeadlines[i]).link) > 0 Then
            St.WriteString( '</A>');
          St.WriteString( ' : <b>[' + FormatDateTime( 'hh:nn', XX_DecodeDate(theadline(gHeadlines[i]).date, True) )  + ']</b>');
        St.WriteString( '</td></tr>' );


        St.WriteString( '<tr><td id=headlineBody>' );
          St.WriteString( theadline(gHeadlines[i]).sisu );
        St.WriteString( '</td></tr>' );

        fNeedDivider := True;
      End;


      If NewsCount = 0 Then Begin
        St.WriteString( '<tr><td id=headlineBody>' );
          St.WriteString( TranslateString('No news...') );
        St.WriteString( '</td></tr>' );
      End;


      St.WriteString( '</TABLE>' );

      St.WriteString( '</BODY>'#13#10 +
                      '</HTML>' );

      ListView1.Selected := Nil;
      ShowHTMLInBrowser( St.datastring );
      embeddedwb1.setfocus;

      actAquaraiumView.Execute;
    Finally
      St.Free;
    End;


    EnterCriticalSection( gCritSect );
    Try
      SortHeadlines( gHeadlines);
    Finally
      LeaveCriticalSection( gCritSect );
    End;
  finally
    Screen.Cursor := crDefault;
    FreeAndNil(AllowedFeeds);
  end;
end;


procedure TMainWindow.actShowPropertiesExecute(Sender: TObject);
Var
  Dlg: TAppOptionsDialog;
begin
  Dlg := TAppOptionsDialog.Create( Self );
  Try
    if (Dlg.ShowModal = mrOK) then
    begin
      gProperties.Save;
//TMPREWORK      embeddedwb1.UserAgent := gProperties.UserAgent;
      TreeView1.ShowLines := gProperties.ShowTreeLines;

      //
      // Start/Stop the WebServers if needed
      //
      if gProperties.EnableUserlandHttpServer then
        EnableUserlandLocalHttpServer( Self, True, gProperties.DataDirectory, OnAddNewFeed )
      else
        EnableUserlandLocalHttpServer( Self, false, gProperties.DataDirectory, OnAddNewFeed );
      if gProperties.EnableWebView then
      begin
        EnableWebViewHttpServer( Self, True, gProperties.DataDirectory, gProperties.WebViewPort );
        image_webaccess.Visible:=true;
      end
      else
      begin
        EnableWebViewHttpServer( Self, false, gProperties.DataDirectory, gProperties.WebViewPort );
        image_webaccess.Visible:=false;
      end;
      if gProperties.EnableAmphetaDeskHttpServer Then
        EnableAmphetaDeskHttpServer( Self, True, gProperties.DataDirectory, OnAddNewFeed )
      else
        EnableAmphetaDeskHttpServer( Self, false, gProperties.DataDirectory, OnAddNewFeed );
    end;
  Finally
    Dlg.Free;
  End;
end;


procedure TMainWindow.actUpdateExecute(Sender: TObject);
begin
  UpdateAllFeeds( True );
end;

procedure TMainWindow.actSearchExecute(Sender: TObject);
begin

end;


procedure TMainWindow.actExitExecute(Sender: TObject);
begin
  //Exit program
//  if Application.MessageBox( PChar(TranslateString('Do you want to close Feedreader?')),
//                             PChar(TranslateString('Exit')), MB_YESNO Or MB_ICONINFORMATION ) = IDYES then
//  begin
    PrepareAppTermination;
    close;
//8  end;
end;

procedure TMainWindow.actUpdateCurrentFeedExecute(Sender: TObject);
begin
  //Update current feed
  if treeview1.selected = nil then
    exit;

  if treeview1.Selected = gMyFeedsTreeNode then
    exit;

  if treeview1.Selected = gAvailableFeedsTreeNode then
    exit;

  if (treeview1.selected.parent <> gMyFeedsTreeNode) and
    (treeview1.Selected.Parent.parent <> gMyFeedsTreeNode) then
    exit;

  if Tfeedinfo(treeview1.Selected.Data).feedtype = 'folder' then
    exit;

  openfeed(treeview1.selected, '', '', true, false);
end;

procedure TMainWindow.actGotoHomepageExecute(Sender: TObject);
Var
  URL: String;
  FeedID: Real;
  i: Integer;
begin
  //Go to active feed homepage
  if treeview1.Selected = nil then
    exit;
  if (treeview1.selected.level = 1) and (treeview1.selected.parent <>
    gMyFeedsTreeNode) then
    exit;
  if (treeview1.selected.level = 2) and (treeview1.selected.parent.parent <>
    gMyFeedsTreeNode) then
    exit;


  URL := Tfeedinfo(treeview1.selected.data).htmlurl;
  If Length(URL) = 0 Then Begin
    FeedID := Tfeedinfo(treeview1.selected.data).feedid;
    For i := Low(gSubscribedFeeds) To High(gSubscribedFeeds) Do
      If FeedID = gSubscribedFeeds[i].FeedID Then Begin
        URL := gSubscribedFeeds[i].htmlurl;
        Break;
      End;
  End;

  If Length(URL) > 0 Then
    ShellExecute(ValidParentForm(Self).Handle, nil, PChar(URL), nil, nil, SW_SHOW);
end;

procedure TMainWindow.actRenameFolderExecute(Sender: TObject);
begin
  //Rename folder
  if treeview1.selected = nil then
    exit;
  if (treeview1.selected.parent <> gMyFeedsTreeNode) and
    (treeview1.selected.parent.parent <> gMyFeedsTreeNode) then
    exit;
  treeview1.Selected.edittext;
end;

procedure TMainWindow.actDeleteCurrentFeedExecute(Sender: TObject);
var feedid:real;
i:integer;
begin
  //Delete current feed
  if treeview1.selected = nil then
    exit;

  if treeview1.Selected = gMyFeedsTreeNode then
    exit;

  if treeview1.Selected = gAvailableFeedsTreeNode then
    exit;

  if (treeview1.selected.parent <> gMyFeedsTreeNode) and
    (treeview1.Selected.Parent.parent <> gMyFeedsTreeNode) then
    exit;

  if Tfeedinfo(treeview1.Selected.Data).feedtype = 'folder' then
    exit;

  if MessageDlg( TranslateString('Do you want to delete active feed?'), mtinformation, [mbOk,mbcancel], 0) <> mrcancel then
     begin
     feedid:=tfeedinfo(treeview1.selected.data).feedid;
     for i:=gheadlines.count-1 downto 0 do
        if theadline(gheadlines[i]).owner=feedid then
          begin
          try
          EnterCriticalSection( gCritSect );
          gheadlines.Delete(i);
          LeaveCriticalSection( gCritSect );
          except
          end;
        end;
     treeview1.selected.delete;
     RecalcUnreadStatus;
     end;
end;

procedure TMainWindow.actShowFeedPropertiesExecute(Sender: TObject);
begin
  //Active feed properties
  if treeview1.Selected = gMyFeedsTreeNode then
    exit;
  if treeview1.Selected = gAvailableFeedsTreeNode then
    exit;

  if (treeview1.selected.parent <> gMyFeedsTreeNode) and
    (treeview1.Selected.Parent.parent <> gMyFeedsTreeNode) then
    exit;

  if Tfeedinfo(treeview1.Selected.Data).feedtype = 'folder' then
    exit;

  if true then begin
    FeedPropertiesForm.caption := Tfeedinfo(treeview1.Selected.data).tiitel + ' ' + TranslateString('Properties');

    FeedPropertiesForm.edit1.text := '';
    FeedPropertiesForm.edit2.text := '';
    FeedPropertiesForm.SetUpdatePeriodId( Tfeedinfo(treeview1.Selected.data).updateperiod );

    FeedPropertiesForm.edit1.text := Tfeedinfo(treeview1.Selected.data).tiitel;
    FeedPropertiesForm.edit2.text := Tfeedinfo(treeview1.Selected.data).link;
    FeedPropertiesForm.un.Text := Tfeedinfo(treeview1.Selected.data).un;
    FeedPropertiesForm.pw.Text := Tfeedinfo(treeview1.Selected.data).pw;
    FeedPropertiesForm.chk_allowaccessfromweb.checked := Tfeedinfo(treeview1.Selected.data).allowfromweb;
    FeedPropertiesForm.SetArchiveSizeID( Tfeedinfo(treeview1.Selected.data).ArchiveSize );
    FeedPropertiesForm.chkAlwaysShowLink.Checked := Tfeedinfo(treeview1.Selected.data).AlwaysShowLink;
    if Tfeedinfo(treeview1.selected.data).feedtype = 'localfeed' then begin
      FeedPropertiesForm.cboUpdatePeriod.visible := false;
      FeedPropertiesForm.label2.visible := false;
    end
    else begin
      FeedPropertiesForm.cboUpdatePeriod.visible := true;
      FeedPropertiesForm.label2.visible := true;
    end;

    Self.Enabled := false;
    FeedPropertiesForm.ShowModal;
  end;
end;

procedure TMainWindow.actRefreshFeedListExecute(Sender: TObject);
var
  i: integer;
begin
  //Refresh feedlist
  if treeview1.Selected.parent <> gAvailableFeedsTreeNode then
    exit;
  treeview1.selected.DeleteChildren;
  //Siin refreshime feedlisti
  for i := 0 to length(gFeedProviderListItems) - 1 do
  begin
    if gFeedProviderListItems[i].owner = TFeedProviderItem(treeview1.selected.Data).docid then
      gFeedProviderListItems[i].deleted := 1;
  end;
  RefreshFeedListFromProvider(treeview1.selected);
  treeview1.selected.expand(true);
end;

procedure TMainWindow.actCheckWebFavoritesExecute(Sender: TObject);
begin
end;


procedure TMainWindow.actSetAllHeadlinesToReadExecute(Sender: TObject);

begin

end;


procedure TMainWindow.actMarkAsUnreadExecute(Sender: TObject);
begin
  if listview1.Selected = nil then
    exit;

  if listview1.selected.data <> nil then
  begin
    while GetHeadlineIndex(true,0, theadline(listview1.Selected.Data).tiitel, theadline(listview1.Selected.Data).link, 1) > -1 do
      theadline(gHeadlines[GetHeadlineIndex(true,0, theadline(listview1.Selected.Data).tiitel, theadline(listview1.Selected.Data).link, 1)]).Read := 0;

    listview1.Selected.ImageIndex := 5;

    theadline(listview1.selected.data).Read := 0;
    // Prevent flashing
    //ListView1.Invalidate;
  end;

  RecalcUnreadStatus;
end;
procedure TMainWindow.actImportOPMLDocumentExecute(Sender: TObject);
var
  ImportOPMLForm: TImportOPMLForm;
//open OPML import form
begin
  {
    Create form dynamically.
    It will be freed in OnFormClose by setting Action to caFree.
  }
  ImportOPMLForm := TImportOPMLForm.Create(nil);
  ImportOPMLForm.lv_opml.items.clear;
  ImportOPMLForm.lv_opml.tag:=0;
  ImportOPMLForm.edt_opmlurl.clear;
  mainwindow.enabled:=false;
  ImportOPMLForm.ShowModal;
end;

procedure TMainWindow.actExportOPMLDocumentExecute(Sender: TObject);
//export feedreader subscriptions as OPML
Var
  DomImplementation: TDomImplementation;
  DomDoc: tdomdocument;
  Element: TdomElement;
  cac,cac0,cac1: TDomElement;
  Node: TTreeNode;
  var savedialog:tsavedialog;
begin
savedialog:=tsavedialog.create(self);
savedialog.filename:='feedreader.opml';
if savedialog.execute then

begin
  Try
    DomImplementation := Nil;
    DomDoc := Nil;
    Try
      DomImplementation := TDomImplementation.Create( Nil );
      DomDoc := TdomDocument.Create( DomImplementation, Nil );
      DomDoc.encoding := 'UTF-8';

      Element := DomDoc.createElement( 'opml' );
      Element.setattribute('version','1.0');
      DomDoc.appendChild( Element );
      cac0 := DomDoc.createElement( 'head' );
      Element.appendChild( cac0 );
      cac0 := DomDoc.createElement( 'body' );
      Element.appendChild( cac0 );

      node := gMyFeedsTreeNode.getFirstChild; //gAvailableFeedsTreeNode
      while (node<>nil) and (node.data<>nil) do
      begin
        if TFeedinfo(node.data).feedtype='folder' then
          begin
          cac1:=DomDoc.createElement('outline');
          cac1.setattribute('title',trim(TFeedinfo(node.data).tiitel));
          cac0.appendchild(cac1);
          end;

        if (node.Level > 0) and (trim(TFeedinfo(node.data).link)<>'') then
        begin
          cac := DomDoc.createElement( 'outline' );
          cac.setattribute('text',escapedelimiters(node.text));
          cac.setattribute('xmlUrl',escapedelimiters(TFeedinfo(node.data).link));
          cac.setattribute('htmlUrl',escapedelimiters(TFeedinfo(node.data).htmlurl));
          cac.setattribute('type','rss');
          cac.setattribute('version','RSS');
          if node.level>1 then
          Cac1.appendChild( cac )
          else
          Cac0.appendChild( cac );
//          AddChildToDomDoc( DomDoc, cac, 'feedtype', TFeedProviderItem(node.data).feedtype );
        end;

        node := node.GetNext;
      end; // while

      SaveDomDocumentToFile( DomDoc, savedialog.filename );

    Finally
      DomDoc.Free;
      DomImplementation.Free;
    End;
  Except
    On E: Exception Do
      Windows.MessageBox( MainWindow.Handle, PChar('Error saving OPML file.'#13#10#13#10 + E.Message), 'Error', MB_ICONHAND OR MB_OK );
  End;
end;
end;

procedure TMainWindow.actRenameFeedExecute(Sender: TObject);
begin
  //Rename feed
  if treeview1.selected = nil then
    exit;
  treeview1.Selected.edittext;
end;

procedure TMainWindow.actNewExternalFeedExecute(Sender: TObject);
begin
  actAddNewFeed.Execute;
end;

procedure TMainWindow.actNewLocalFeedExecute(Sender: TObject);
begin
  actCreateNewLocalFeed.Execute;
end;
procedure TMainWindow.actCheckForNewVersionExecute(Sender: TObject);
var
  Http: THttpCli;
  NewVersion: String;
  Stream: TStringStream;
  NewVersionForm: TNewVersionForm;
begin
//  Self.Enabled := False;
  Try

    Stream := TStringStream.Create( '' );
    Try
      Http := THttpCli.Create( Self );
      Try

        Http.RcvdStream := Stream;
        Http.URL := 'http://feedreader.sourceforge.net/version.txt';
        Http.Get;

        If Http.StatusCode = 200 Then Begin
          NewVersion := Stream.DataString;

          // remove trailing newlines, etc.
          While (Length(NewVersion) > 0) And (Ord(NewVersion[Length(NewVersion)]) < 32) Do SetLength( NewVersion, Length(NewVersion) - 1 );
          NewVersion := Trim(NewVersion);

          Self.Enabled := True;
          If NewVersion <> xfunctions.GetFileVersion(Application.ExeName) Then
            begin
 //           Close;
            {
              This is not a memory leak as in the OnClose-Event the close-
              action is set to caFree.
            }
            NewVersionForm := TNewVersionForm.Create(nil);
            NewVersionForm.FRVerLabel.Caption:=NewVersion;
            NewVersionForm.ProgressBar1.visible:=false;
            NewVersionForm.show;
            mainwindow.enabled:=false;
            end
           Else
            ShowMessage( TranslateString('No new version is available at this time') );

        End
         Else Begin
//           Self.Enabled := True;
           ShowMessage( TranslateString('Error') + ':' + Http.LastResponse );
         End;

      Finally
        Http.Free;
      End;
    Finally
      Stream.Free;
    End;

  Finally
//    Self.Enabled := True;

  End;

end;
