(*
 *   FeedReader
 *   Copyright (C) 2003 The FeedReader Developement Group
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *)
unit NewBubbleForm_FRM;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, ComCtrls, Controls,
  Forms, Dialogs, ExtCtrls, OleCtrls, StdCtrls,
  Misc;

const
  xMY_POST_ENTER = WM_USER + 500;

type
  TNewBubbleWindow_old = class(TForm)
    Timer1: TTimer;
    Timer2: TTimer;
    ClosingTimer: TTimer;
    Memo1: TMemo;
    ListBox1: TListBox;
    procedure Timer1Timer(Sender: TObject);
    procedure Panel1Click(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure enter(Sender: TObject);
    procedure leave(Sender: TObject);
    procedure FormClick(Sender: TObject);
    procedure Memo1Click(Sender: TObject);
    procedure Memo1Change(Sender: TObject);
    procedure Memo1Exit(Sender: TObject);
    procedure Memo1Enter(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    node: ttreenode;

    procedure MyPost_Enter(var Message: TMessage); message xMY_POST_ENTER;

  end;

var
  NewBubbleWindow_old: TNewBubbleWindow_old;

implementation

uses MainForm_FRM;

{$R *.dfm}

procedure TNewBubbleWindow_old.Timer1Timer(Sender: TObject);
begin
  AlphaBlendValue := alphablendvalue + 10;
  if AlphaBlendvalue >= 250 then
  begin
    alphablendvalue := 255;
    timer1.enabled := false;
    ClosingTimer.enabled := true;
  end;

end;

procedure TNewBubbleWindow_old.Panel1Click(Sender: TObject);
begin
  ClosingTimer.enabled := false;
  timer2.enabled := true;
end;

procedure TNewBubbleWindow_old.Timer2Timer(Sender: TObject);
begin
  AlphaBlendValue := alphablendvalue - 10;
  if AlphaBlendvalue < 20 then
  begin
    timer2.Enabled := false;
    AlphaBlendValue := 0;
    tag := 0;
    close;
    release;
  end;
end;

procedure TNewBubbleWindow_old.MyPost_Enter(var Message: TMessage);
begin
  CreateCaret(Memo1.handle, 0, 0, 0);
end;

procedure TNewBubbleWindow_old.enter(Sender: TObject);
begin
  tlabel(sender).Font.Color := clactivecaption;
end;

procedure TNewBubbleWindow_old.leave(Sender: TObject);
begin
  tlabel(sender).Font.Color := clbackground;
end;

procedure TNewBubbleWindow_old.FormClick(Sender: TObject);
begin
  Panel1Click(sender);
end;

procedure TNewBubbleWindow_old.Memo1Click(Sender: TObject);
var
  positsioon: integer;
begin
  PostMessage(Handle, xMY_POST_ENTER, 0, 0);
  mainwindow.actShowWindow.Execute;
  mainwindow.TreeView1.Selected := node;
  positsioon := memo1.Perform(EM_LINEFROMCHAR, Memo1.SelStart, 0);
  if mainwindow.ListView1.Items[positsioon] <> nil then
  begin
    mainwindow.ListView1.Items[positsioon].Selected := true;
    mainwindow.showart(mainwindow.listview1.items[positsioon]);
  end;
end;

procedure TNewBubbleWindow_old.Memo1Change(Sender: TObject);
begin
  CreateCaret(Memo1.handle, 0, 0, 0);

end;

procedure TNewBubbleWindow_old.Memo1Exit(Sender: TObject);
begin
  CreateCaret(Memo1.handle, 1, 1, 1);
end;

procedure TNewBubbleWindow_old.Memo1Enter(Sender: TObject);
begin
  PostMessage(Handle, xMY_POST_ENTER, 0, 0);

end;

procedure TNewBubbleWindow_old.ListBox1Click(Sender: TObject);
var
  ListItem: TListItem;
  i: Integer;
  ItemText: String;
begin
  if listbox1.Itemindex = -1 then
    exit;

  mainwindow.TreeView1.Selected := node;

  ItemText := ListBox1.Items[ ListBox1.ItemIndex ];
  ListItem := Nil;
  For i := 0 To MainWindow.ListView1.Items.Count-1 Do
    If 0 = CompareText( Trim(ItemText), Trim(MainWindow.ListView1.Items[i].SubItems[1]) ) Then Begin
      ListItem := MainWindow.ListView1.Items[i];
      Break;
    End;

  if ListItem <> Nil Then
  begin
    mainwindow.actShowWindow.Execute;
    ListItem.Selected := true;
    ListItem.MakeVisible( False );
    mainwindow.ListView1Click(sender);
  end;

end;

end.
