(*
 *   FeedReader
 *   Copyright (C) 2003 The FeedReader Developement Group
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *)
unit SplashScreen_FRM;

interface

uses
  Windows, Forms, ShellAPI,StdCtrls, Graphics, Controls, ExtCtrls, Classes, ComCtrls,
  SysUtils;

type
  TSplashScreen = class(TForm)
    FlatPanel1: TPanel;
    Image1: TImage;
    Label1: TLabel;
    Label5: TLabel;
    statusprogress: TProgressBar;
    lblVersion: TLabel;
    lblVersionNo: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure visithomepage(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  SplashScreen: TSplashScreen;

implementation

Uses
  FReaderProperties, Misc;

{$R *.DFM}

procedure TSplashScreen.FormCreate(Sender: TObject);
var
  VersionString: string;
begin
  {$IFOPT D-}
  Self.FormStyle := fsStayOnTop;
  {$ENDIF}

  VersionString := Sto_GetFileVersion(Application.ExeName, 4);
  lblVersionNo.Caption := IntToStr(StrToInt(Copy(VersionString, 1, Pos('.', VersionString)-1)))
                        + '.';
  Delete(VersionString, 1, Pos('.', VersionString));
  lblVersionNo.Caption := lblVersionNo.Caption
                        + IntToStr(StrToInt(Copy(VersionString, 1, Pos('.', VersionString)-1)));
end;

procedure TSplashScreen.FormShow(Sender: TObject);
begin
  // this prevents the application-window from beging shown during the splash-screen display
  ShowWindow(Application.Handle, SW_HIDE);
end;

procedure TSplashScreen.visithomepage(Sender: TObject);
begin
ShellExecute(ValidParentForm(Self).Handle, nil, PChar('http://www.feedreader.com/'), nil, nil, SW_SHOW);

end;

end.
