unit uCreateXMLTranslationFileMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    lblInputFilename: TLabel;
    edtInputfile: TEdit;
    mmoInfo: TMemo;
    btnOpenfile: TButton;
    btnCreateXML: TButton;
    OpenDialog: TOpenDialog;
    procedure btnCreateXMLClick(Sender: TObject);
    procedure btnOpenfileClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.btnCreateXMLClick(Sender: TObject);
var
  i: integer;
  Outputfile: TStringList;
  InputFile: TStringList;

begin
  if (edtInputfile.Text = '') then
  begin
    MessageDlg('Choose inputfile.', mtWarning, [mbOK], 0);
    exit;
  end;
  OutputFile := TStringList.Create;
  InputFile := TStringList.Create;
  InputFile.LoadFromFile(edtInputfile.Text);
  OutputFile.Add('<?xml version="1.0" encoding="UTF-8"?>');
  OutputFile.Add('<translation language=""><item english="' + InputFile[0] +'"');
  OutputFile.Add('translated=""></item>');
  try
    for i := 1 to InputFile.Count-1 do
    begin
      OutputFile.Add('<item english="' + InputFile[i] + '"');
      OutputFile.Add('translated=""></item>');
    end;
    OutputFile.Add('</translation>');
    OutputFile.SaveToFile(ExtractFilePath(edtInputfile.Text) + 'translation.xml');
  finally
    FreeAndNil(OutputFile);
  end;
  Close;
end;

procedure TForm1.btnOpenfileClick(Sender: TObject);
begin
  if OpenDialog.Execute then
  begin
    edtInputfile.Text := OpenDialog.FileName;
  end;
end;

end.
