//-------------------------------------------------------
// Autor     : Edison Henrique Andreassy
// Data      : 27/12/2000
// Descricao : Unit para retirar os tags de HTML
//
// Notas     : Voce pode usar e abusar deste codigo
//             Este cdigo usa a Unit UVBasic.pas
//-------------------------------------------------------
unit UHTML2Text;

interface

uses
   UVBasic, SysUtils;

   function HTML2Text(OrigHTML: String): String;
   function MidStr(const pString, pAbre, pFecha: String; pInclui: boolean): string;

implementation

//-------------------------------------------------------
// Tira Codigos HTML
//-------------------------------------------------------
function HTML2Text(OrigHTML: String): String;
const
   NovaLinha = Chr(13) + Chr(10);
var
   NoHTML: String;
begin
   //Separa somente o corpo do texto HTML
   if Pos('<body', LowerCase(OrigHTML)) > 0 Then begin
      OrigHTML := Mid(OrigHTML, Pos('<body', LowerCase(OrigHTML)));
      OrigHTML := Mid(OrigHTML, Pos('>', OrigHTML) + 1);
      if Pos('</body>', LowerCase(OrigHTML)) > 0 Then
         OrigHTML := Copy(OrigHTML, 1 , Pos('</body>', LowerCase(OrigHTML)) - 1);
   end;

   //Retira os caracteres de nova linha
   OrigHTML := StringReplace(OrigHTML, Chr(13), '', [rfReplaceAll]);
   OrigHTML := StringReplace(OrigHTML, Chr(10), '', [rfReplaceAll]);

   //Retira espacos duplos
   while Pos('  ', OrigHTML) > 0 do
      OrigHTML := StringReplace(OrigHTML, '  ', ' ', [rfReplaceAll]);

   //Modifica tags de nova linha, por caracteres de nova linha
   OrigHTML := StringReplace(OrigHTML, '<br>', NovaLinha, [rfReplaceAll, rfIgnoreCase]);
   OrigHTML := StringReplace(OrigHTML, '</div>', NovaLinha + NovaLinha, [rfReplaceAll, rfIgnoreCase]);

   //Modifita tag de paragrafo por caracteres de nova linha
   while Pos('<p', OrigHTML) > 0 do begin
      NoHTML   := MidStr(OrigHTML, '<p', '>', True);
      OrigHTML := StringReplace(OrigHTML, NoHTML, (NovaLinha + NovaLinha), [rfReplaceAll, rfIgnoreCase]);
   end;

   //Tratamento de Tags em Geral
   while Pos('<', OrigHTML) > 0 do begin
      NoHTML   := MidStr(OrigHTML, '<', '>', True);
      OrigHTML := StringReplace(OrigHTML, NoHTML, '', [rfReplaceAll, rfIgnoreCase]);
   end;

   //Trata Caracteres especiais
   OrigHTML := StringReplace(OrigHTML, '&#36;',     '$', [rfReplaceAll]);
   OrigHTML := StringReplace(OrigHTML, '#37;',      '%', [rfReplaceAll]);
   OrigHTML := StringReplace(OrigHTML, '&#187;',    '', [rfReplaceAll]);
   OrigHTML := StringReplace(OrigHTML, '&aacute;',  '', [rfReplaceAll]);
   OrigHTML := StringReplace(OrigHTML, '&atilde;',  '', [rfReplaceAll]);
   OrigHTML := StringReplace(OrigHTML, '&ccedil;',  '', [rfReplaceAll]);
   OrigHTML := StringReplace(OrigHTML, '&eacute;',  '', [rfReplaceAll]);
   OrigHTML := StringReplace(OrigHTML, '&ecirc;',   '', [rfReplaceAll]);
   OrigHTML := StringReplace(OrigHTML, '&iacute;',  '', [rfReplaceAll]);
   OrigHTML := StringReplace(OrigHTML, '&oacute;',  '', [rfReplaceAll]);
   OrigHTML := StringReplace(OrigHTML, '&ocirc;',   '', [rfReplaceAll]);
   OrigHTML := StringReplace(OrigHTML, '&otilde;',  '', [rfReplaceAll]);
   OrigHTML := StringReplace(OrigHTML, '&Aacute;',  '', [rfReplaceAll]);
   OrigHTML := StringReplace(OrigHTML, '&Atilde;',  '', [rfReplaceAll]);
   OrigHTML := StringReplace(OrigHTML, '&Ccedil;',  '', [rfReplaceAll]);
   OrigHTML := StringReplace(OrigHTML, '&Eacute;',  '', [rfReplaceAll]);
   OrigHTML := StringReplace(OrigHTML, '&Ecirc;',   '', [rfReplaceAll]);
   OrigHTML := StringReplace(OrigHTML, '&Iacute;',  '', [rfReplaceAll]);
   OrigHTML := StringReplace(OrigHTML, '&Oacute;',  '', [rfReplaceAll]);
   OrigHTML := StringReplace(OrigHTML, '&Ocirc;',   '', [rfReplaceAll]);
   OrigHTML := StringReplace(OrigHTML, '&Otilde;',  '', [rfReplaceAll]);
   OrigHTML := StringReplace(OrigHTML, '&amp;',     '&', [rfReplaceAll]);
   OrigHTML := StringReplace(OrigHTML, '&quot;',    '"', [rfReplaceAll]);
   OrigHTML := StringReplace(OrigHTML, '&lt;',      '<', [rfReplaceAll]);
   OrigHTML := StringReplace(OrigHTML, '&gt;',      '>', [rfReplaceAll]);
   OrigHTML := StringReplace(OrigHTML, '&nbsp;',    ' ', [rfReplaceAll]);
   OrigHTML := StringReplace(OrigHTML, '&copy;',    '', [rfReplaceAll]);
   OrigHTML := StringReplace(OrigHTML, '&reg;',     '', [rfReplaceAll]);
   OrigHTML := StringReplace(OrigHTML, '&raquo;',   '', [rfReplaceAll]);
   OrigHTML := StringReplace(OrigHTML, '&Uacute;',  '', [rfReplaceAll]);
   OrigHTML := StringReplace(OrigHTML, '&uacute;',  '', [rfReplaceAll]);
   OrigHTML := StringReplace(OrigHTML, '&uuml;',    '', [rfReplaceAll]);

   result := OrigHTML
end;

//-------------------------------------------------------
// MidStr
//-------------------------------------------------------
function MidStr(const pString, pAbre, pFecha: String; pInclui: boolean): string;
var
   lIni, lFim: integer;
begin
   if (pInclui = False) then begin
      lIni := Pos(UpperCase(pAbre), UpperCase(pString)) + Length(pAbre);
      lFim := InStr(lIni, UpperCase(pString), UpperCase(pFecha));
   end else begin
      lIni := Pos(UpperCase(pAbre), UpperCase(pString));
      lFim := InStr(lIni + Length(pAbre), UpperCase(pString), UpperCase(pFecha)) + Length(pFecha);
   end;
   result := Copy(pString, lIni, lFim - lIni);
end;

end.
